; MAPF/DU domain (FOND version) with 8 worlds for 3 agents
; Author: Thorsten Engesser
(define (domain mapfdu_3_agents)
  (:types agt world pos)
  (:constants w0 w1 w2 w3 w4 w5 w6 w7 - world
              a0 a1 a2 - agt)
  (:predicates
    (at ?a - agt ?p - pos)
    (adj ?p1 ?p2 - pos)
    (stopped ?a - agt)
    (goal ?w - world ?a - agt ?p - pos)
    (ind ?a - agt ?w1 ?w2 - world)
    (des ?w - world)
    (next-choose)
    (next-move ?a - agt ?p1 ?p2 - pos)
    (next-annc ?a - agt ?p - pos))
  (:action choose-move ; UNFAIR ACTION!
     :parameters (?a - agt ?w - world ?p1 ?p2 - pos)
     :precondition (and (des ?w) (next-choose)
                        (at ?a ?p1) (adj ?p1 ?p2)
                        (and (not (at a0 ?p2)) (not (at a1 ?p2)) (not (at a2 ?p2)))
                        (not (stopped ?a)))
     :effect (and (next-move ?a ?p1 ?p2) (not (next-choose))
                  (oneof 
                         (when (and (ind ?a ?w w0) (not (= ?w w0)))
                               (and (not (des ?w)) (des w0)))
                         (when (and (ind ?a ?w w1) (not (= ?w w1)))
                               (and (not (des ?w)) (des w1)))
                         (when (and (ind ?a ?w w2) (not (= ?w w2)))
                               (and (not (des ?w)) (des w2)))
                         (when (and (ind ?a ?w w3) (not (= ?w w3)))
                               (and (not (des ?w)) (des w3)))
                         (when (and (ind ?a ?w w4) (not (= ?w w4)))
                               (and (not (des ?w)) (des w4)))
                         (when (and (ind ?a ?w w5) (not (= ?w w5)))
                               (and (not (des ?w)) (des w5)))
                         (when (and (ind ?a ?w w6) (not (= ?w w6)))
                               (and (not (des ?w)) (des w6)))
                         (when (and (ind ?a ?w w7) (not (= ?w w7)))
                               (and (not (des ?w)) (des w7))))))
  (:action choose-announce ; UNFAIR ACTION!
     :parameters (?a - agt ?w - world ?p - pos)
     :precondition (and (des ?w) (next-choose)
                        (at ?a ?p) (goal ?w ?a ?p)
                        (not (stopped ?a)))
     :effect (and (next-annc ?a ?p) (not (next-choose))
                  (oneof 
                         (when (and (ind ?a ?w w0) (not (= ?w w0)))
                               (and (not (des ?w)) (des w0)))
                         (when (and (ind ?a ?w w1) (not (= ?w w1)))
                               (and (not (des ?w)) (des w1)))
                         (when (and (ind ?a ?w w2) (not (= ?w w2)))
                               (and (not (des ?w)) (des w2)))
                         (when (and (ind ?a ?w w3) (not (= ?w w3)))
                               (and (not (des ?w)) (des w3)))
                         (when (and (ind ?a ?w w4) (not (= ?w w4)))
                               (and (not (des ?w)) (des w4)))
                         (when (and (ind ?a ?w w5) (not (= ?w w5)))
                               (and (not (des ?w)) (des w5)))
                         (when (and (ind ?a ?w w6) (not (= ?w w6)))
                               (and (not (des ?w)) (des w6)))
                         (when (and (ind ?a ?w w7) (not (= ?w w7)))
                               (and (not (des ?w)) (des w7))))))
  (:action move
     :parameters (?a - agt ?w - world ?p1 ?p2 - pos)
     :precondition (and (des ?w) (next-move ?a ?p1 ?p2))
     :effect (and (not (at ?a ?p1)) (at ?a ?p2)
                  (not (next-move ?a ?p1 ?p2))
                  (next-choose)))
  (:action announce
     :parameters (?a - agt ?w - world ?p - pos)
     :precondition (and (des ?w) (next-annc ?a ?p)
                        (goal ?w ?a ?p))
     :effect (and (stopped ?a)
                  (not (next-annc ?a ?p)) (next-choose)
                  (when (not (goal w0 ?a ?p))
                        (and (not (ind a0 w0 w0)) (not (ind a0 w0 w0))
                             (not (ind a0 w0 w1)) (not (ind a0 w1 w0))
                             (not (ind a0 w0 w2)) (not (ind a0 w2 w0))
                             (not (ind a0 w0 w3)) (not (ind a0 w3 w0))
                             (not (ind a0 w0 w4)) (not (ind a0 w4 w0))
                             (not (ind a0 w0 w5)) (not (ind a0 w5 w0))
                             (not (ind a0 w0 w6)) (not (ind a0 w6 w0))
                             (not (ind a0 w0 w7)) (not (ind a0 w7 w0))
                             (not (ind a1 w0 w0)) (not (ind a1 w0 w0))
                             (not (ind a1 w0 w1)) (not (ind a1 w1 w0))
                             (not (ind a1 w0 w2)) (not (ind a1 w2 w0))
                             (not (ind a1 w0 w3)) (not (ind a1 w3 w0))
                             (not (ind a1 w0 w4)) (not (ind a1 w4 w0))
                             (not (ind a1 w0 w5)) (not (ind a1 w5 w0))
                             (not (ind a1 w0 w6)) (not (ind a1 w6 w0))
                             (not (ind a1 w0 w7)) (not (ind a1 w7 w0))
                             (not (ind a2 w0 w0)) (not (ind a2 w0 w0))
                             (not (ind a2 w0 w1)) (not (ind a2 w1 w0))
                             (not (ind a2 w0 w2)) (not (ind a2 w2 w0))
                             (not (ind a2 w0 w3)) (not (ind a2 w3 w0))
                             (not (ind a2 w0 w4)) (not (ind a2 w4 w0))
                             (not (ind a2 w0 w5)) (not (ind a2 w5 w0))
                             (not (ind a2 w0 w6)) (not (ind a2 w6 w0))
                             (not (ind a2 w0 w7)) (not (ind a2 w7 w0))))
                  (when (not (goal w1 ?a ?p))
                        (and (not (ind a0 w1 w0)) (not (ind a0 w0 w1))
                             (not (ind a0 w1 w1)) (not (ind a0 w1 w1))
                             (not (ind a0 w1 w2)) (not (ind a0 w2 w1))
                             (not (ind a0 w1 w3)) (not (ind a0 w3 w1))
                             (not (ind a0 w1 w4)) (not (ind a0 w4 w1))
                             (not (ind a0 w1 w5)) (not (ind a0 w5 w1))
                             (not (ind a0 w1 w6)) (not (ind a0 w6 w1))
                             (not (ind a0 w1 w7)) (not (ind a0 w7 w1))
                             (not (ind a1 w1 w0)) (not (ind a1 w0 w1))
                             (not (ind a1 w1 w1)) (not (ind a1 w1 w1))
                             (not (ind a1 w1 w2)) (not (ind a1 w2 w1))
                             (not (ind a1 w1 w3)) (not (ind a1 w3 w1))
                             (not (ind a1 w1 w4)) (not (ind a1 w4 w1))
                             (not (ind a1 w1 w5)) (not (ind a1 w5 w1))
                             (not (ind a1 w1 w6)) (not (ind a1 w6 w1))
                             (not (ind a1 w1 w7)) (not (ind a1 w7 w1))
                             (not (ind a2 w1 w0)) (not (ind a2 w0 w1))
                             (not (ind a2 w1 w1)) (not (ind a2 w1 w1))
                             (not (ind a2 w1 w2)) (not (ind a2 w2 w1))
                             (not (ind a2 w1 w3)) (not (ind a2 w3 w1))
                             (not (ind a2 w1 w4)) (not (ind a2 w4 w1))
                             (not (ind a2 w1 w5)) (not (ind a2 w5 w1))
                             (not (ind a2 w1 w6)) (not (ind a2 w6 w1))
                             (not (ind a2 w1 w7)) (not (ind a2 w7 w1))))
                  (when (not (goal w2 ?a ?p))
                        (and (not (ind a0 w2 w0)) (not (ind a0 w0 w2))
                             (not (ind a0 w2 w1)) (not (ind a0 w1 w2))
                             (not (ind a0 w2 w2)) (not (ind a0 w2 w2))
                             (not (ind a0 w2 w3)) (not (ind a0 w3 w2))
                             (not (ind a0 w2 w4)) (not (ind a0 w4 w2))
                             (not (ind a0 w2 w5)) (not (ind a0 w5 w2))
                             (not (ind a0 w2 w6)) (not (ind a0 w6 w2))
                             (not (ind a0 w2 w7)) (not (ind a0 w7 w2))
                             (not (ind a1 w2 w0)) (not (ind a1 w0 w2))
                             (not (ind a1 w2 w1)) (not (ind a1 w1 w2))
                             (not (ind a1 w2 w2)) (not (ind a1 w2 w2))
                             (not (ind a1 w2 w3)) (not (ind a1 w3 w2))
                             (not (ind a1 w2 w4)) (not (ind a1 w4 w2))
                             (not (ind a1 w2 w5)) (not (ind a1 w5 w2))
                             (not (ind a1 w2 w6)) (not (ind a1 w6 w2))
                             (not (ind a1 w2 w7)) (not (ind a1 w7 w2))
                             (not (ind a2 w2 w0)) (not (ind a2 w0 w2))
                             (not (ind a2 w2 w1)) (not (ind a2 w1 w2))
                             (not (ind a2 w2 w2)) (not (ind a2 w2 w2))
                             (not (ind a2 w2 w3)) (not (ind a2 w3 w2))
                             (not (ind a2 w2 w4)) (not (ind a2 w4 w2))
                             (not (ind a2 w2 w5)) (not (ind a2 w5 w2))
                             (not (ind a2 w2 w6)) (not (ind a2 w6 w2))
                             (not (ind a2 w2 w7)) (not (ind a2 w7 w2))))
                  (when (not (goal w3 ?a ?p))
                        (and (not (ind a0 w3 w0)) (not (ind a0 w0 w3))
                             (not (ind a0 w3 w1)) (not (ind a0 w1 w3))
                             (not (ind a0 w3 w2)) (not (ind a0 w2 w3))
                             (not (ind a0 w3 w3)) (not (ind a0 w3 w3))
                             (not (ind a0 w3 w4)) (not (ind a0 w4 w3))
                             (not (ind a0 w3 w5)) (not (ind a0 w5 w3))
                             (not (ind a0 w3 w6)) (not (ind a0 w6 w3))
                             (not (ind a0 w3 w7)) (not (ind a0 w7 w3))
                             (not (ind a1 w3 w0)) (not (ind a1 w0 w3))
                             (not (ind a1 w3 w1)) (not (ind a1 w1 w3))
                             (not (ind a1 w3 w2)) (not (ind a1 w2 w3))
                             (not (ind a1 w3 w3)) (not (ind a1 w3 w3))
                             (not (ind a1 w3 w4)) (not (ind a1 w4 w3))
                             (not (ind a1 w3 w5)) (not (ind a1 w5 w3))
                             (not (ind a1 w3 w6)) (not (ind a1 w6 w3))
                             (not (ind a1 w3 w7)) (not (ind a1 w7 w3))
                             (not (ind a2 w3 w0)) (not (ind a2 w0 w3))
                             (not (ind a2 w3 w1)) (not (ind a2 w1 w3))
                             (not (ind a2 w3 w2)) (not (ind a2 w2 w3))
                             (not (ind a2 w3 w3)) (not (ind a2 w3 w3))
                             (not (ind a2 w3 w4)) (not (ind a2 w4 w3))
                             (not (ind a2 w3 w5)) (not (ind a2 w5 w3))
                             (not (ind a2 w3 w6)) (not (ind a2 w6 w3))
                             (not (ind a2 w3 w7)) (not (ind a2 w7 w3))))
                  (when (not (goal w4 ?a ?p))
                        (and (not (ind a0 w4 w0)) (not (ind a0 w0 w4))
                             (not (ind a0 w4 w1)) (not (ind a0 w1 w4))
                             (not (ind a0 w4 w2)) (not (ind a0 w2 w4))
                             (not (ind a0 w4 w3)) (not (ind a0 w3 w4))
                             (not (ind a0 w4 w4)) (not (ind a0 w4 w4))
                             (not (ind a0 w4 w5)) (not (ind a0 w5 w4))
                             (not (ind a0 w4 w6)) (not (ind a0 w6 w4))
                             (not (ind a0 w4 w7)) (not (ind a0 w7 w4))
                             (not (ind a1 w4 w0)) (not (ind a1 w0 w4))
                             (not (ind a1 w4 w1)) (not (ind a1 w1 w4))
                             (not (ind a1 w4 w2)) (not (ind a1 w2 w4))
                             (not (ind a1 w4 w3)) (not (ind a1 w3 w4))
                             (not (ind a1 w4 w4)) (not (ind a1 w4 w4))
                             (not (ind a1 w4 w5)) (not (ind a1 w5 w4))
                             (not (ind a1 w4 w6)) (not (ind a1 w6 w4))
                             (not (ind a1 w4 w7)) (not (ind a1 w7 w4))
                             (not (ind a2 w4 w0)) (not (ind a2 w0 w4))
                             (not (ind a2 w4 w1)) (not (ind a2 w1 w4))
                             (not (ind a2 w4 w2)) (not (ind a2 w2 w4))
                             (not (ind a2 w4 w3)) (not (ind a2 w3 w4))
                             (not (ind a2 w4 w4)) (not (ind a2 w4 w4))
                             (not (ind a2 w4 w5)) (not (ind a2 w5 w4))
                             (not (ind a2 w4 w6)) (not (ind a2 w6 w4))
                             (not (ind a2 w4 w7)) (not (ind a2 w7 w4))))
                  (when (not (goal w5 ?a ?p))
                        (and (not (ind a0 w5 w0)) (not (ind a0 w0 w5))
                             (not (ind a0 w5 w1)) (not (ind a0 w1 w5))
                             (not (ind a0 w5 w2)) (not (ind a0 w2 w5))
                             (not (ind a0 w5 w3)) (not (ind a0 w3 w5))
                             (not (ind a0 w5 w4)) (not (ind a0 w4 w5))
                             (not (ind a0 w5 w5)) (not (ind a0 w5 w5))
                             (not (ind a0 w5 w6)) (not (ind a0 w6 w5))
                             (not (ind a0 w5 w7)) (not (ind a0 w7 w5))
                             (not (ind a1 w5 w0)) (not (ind a1 w0 w5))
                             (not (ind a1 w5 w1)) (not (ind a1 w1 w5))
                             (not (ind a1 w5 w2)) (not (ind a1 w2 w5))
                             (not (ind a1 w5 w3)) (not (ind a1 w3 w5))
                             (not (ind a1 w5 w4)) (not (ind a1 w4 w5))
                             (not (ind a1 w5 w5)) (not (ind a1 w5 w5))
                             (not (ind a1 w5 w6)) (not (ind a1 w6 w5))
                             (not (ind a1 w5 w7)) (not (ind a1 w7 w5))
                             (not (ind a2 w5 w0)) (not (ind a2 w0 w5))
                             (not (ind a2 w5 w1)) (not (ind a2 w1 w5))
                             (not (ind a2 w5 w2)) (not (ind a2 w2 w5))
                             (not (ind a2 w5 w3)) (not (ind a2 w3 w5))
                             (not (ind a2 w5 w4)) (not (ind a2 w4 w5))
                             (not (ind a2 w5 w5)) (not (ind a2 w5 w5))
                             (not (ind a2 w5 w6)) (not (ind a2 w6 w5))
                             (not (ind a2 w5 w7)) (not (ind a2 w7 w5))))
                  (when (not (goal w6 ?a ?p))
                        (and (not (ind a0 w6 w0)) (not (ind a0 w0 w6))
                             (not (ind a0 w6 w1)) (not (ind a0 w1 w6))
                             (not (ind a0 w6 w2)) (not (ind a0 w2 w6))
                             (not (ind a0 w6 w3)) (not (ind a0 w3 w6))
                             (not (ind a0 w6 w4)) (not (ind a0 w4 w6))
                             (not (ind a0 w6 w5)) (not (ind a0 w5 w6))
                             (not (ind a0 w6 w6)) (not (ind a0 w6 w6))
                             (not (ind a0 w6 w7)) (not (ind a0 w7 w6))
                             (not (ind a1 w6 w0)) (not (ind a1 w0 w6))
                             (not (ind a1 w6 w1)) (not (ind a1 w1 w6))
                             (not (ind a1 w6 w2)) (not (ind a1 w2 w6))
                             (not (ind a1 w6 w3)) (not (ind a1 w3 w6))
                             (not (ind a1 w6 w4)) (not (ind a1 w4 w6))
                             (not (ind a1 w6 w5)) (not (ind a1 w5 w6))
                             (not (ind a1 w6 w6)) (not (ind a1 w6 w6))
                             (not (ind a1 w6 w7)) (not (ind a1 w7 w6))
                             (not (ind a2 w6 w0)) (not (ind a2 w0 w6))
                             (not (ind a2 w6 w1)) (not (ind a2 w1 w6))
                             (not (ind a2 w6 w2)) (not (ind a2 w2 w6))
                             (not (ind a2 w6 w3)) (not (ind a2 w3 w6))
                             (not (ind a2 w6 w4)) (not (ind a2 w4 w6))
                             (not (ind a2 w6 w5)) (not (ind a2 w5 w6))
                             (not (ind a2 w6 w6)) (not (ind a2 w6 w6))
                             (not (ind a2 w6 w7)) (not (ind a2 w7 w6))))
                  (when (not (goal w7 ?a ?p))
                        (and (not (ind a0 w7 w0)) (not (ind a0 w0 w7))
                             (not (ind a0 w7 w1)) (not (ind a0 w1 w7))
                             (not (ind a0 w7 w2)) (not (ind a0 w2 w7))
                             (not (ind a0 w7 w3)) (not (ind a0 w3 w7))
                             (not (ind a0 w7 w4)) (not (ind a0 w4 w7))
                             (not (ind a0 w7 w5)) (not (ind a0 w5 w7))
                             (not (ind a0 w7 w6)) (not (ind a0 w6 w7))
                             (not (ind a0 w7 w7)) (not (ind a0 w7 w7))
                             (not (ind a1 w7 w0)) (not (ind a1 w0 w7))
                             (not (ind a1 w7 w1)) (not (ind a1 w1 w7))
                             (not (ind a1 w7 w2)) (not (ind a1 w2 w7))
                             (not (ind a1 w7 w3)) (not (ind a1 w3 w7))
                             (not (ind a1 w7 w4)) (not (ind a1 w4 w7))
                             (not (ind a1 w7 w5)) (not (ind a1 w5 w7))
                             (not (ind a1 w7 w6)) (not (ind a1 w6 w7))
                             (not (ind a1 w7 w7)) (not (ind a1 w7 w7))
                             (not (ind a2 w7 w0)) (not (ind a2 w0 w7))
                             (not (ind a2 w7 w1)) (not (ind a2 w1 w7))
                             (not (ind a2 w7 w2)) (not (ind a2 w2 w7))
                             (not (ind a2 w7 w3)) (not (ind a2 w3 w7))
                             (not (ind a2 w7 w4)) (not (ind a2 w4 w7))
                             (not (ind a2 w7 w5)) (not (ind a2 w5 w7))
                             (not (ind a2 w7 w6)) (not (ind a2 w6 w7))
                             (not (ind a2 w7 w7)) (not (ind a2 w7 w7)))))))
