; MAPF/DU domain (FOND version) with 16 worlds for 4 agents
; Author: Thorsten Engesser
(define (domain mapfdu_4_agents)
  (:types agt world pos)
  (:constants w0 w1 w2 w3 w4 w5 w6 w7 w8 w9 w10 w11 w12 w13 w14 w15 - world
              a0 a1 a2 a3 - agt)
  (:predicates
    (at ?a - agt ?p - pos)
    (adj ?p1 ?p2 - pos)
    (stopped ?a - agt)
    (goal ?w - world ?a - agt ?p - pos)
    (ind ?a - agt ?w1 ?w2 - world)
    (des ?w - world)
    (next-choose)
    (next-move ?a - agt ?p1 ?p2 - pos)
    (next-annc ?a - agt ?p - pos))
  (:action choose-move ; UNFAIR ACTION!
     :parameters (?a - agt ?w - world ?p1 ?p2 - pos)
     :precondition (and (des ?w) (next-choose)
                        (at ?a ?p1) (adj ?p1 ?p2)
                        (and (not (at a0 ?p2)) (not (at a1 ?p2)) (not (at a2 ?p2)) (not (at a3 ?p2)))
                        (not (stopped ?a)))
     :effect (and (next-move ?a ?p1 ?p2) (not (next-choose))
                  (oneof 
                         (when (and (ind ?a ?w w0) (not (= ?w w0)))
                               (and (not (des ?w)) (des w0)))
                         (when (and (ind ?a ?w w1) (not (= ?w w1)))
                               (and (not (des ?w)) (des w1)))
                         (when (and (ind ?a ?w w2) (not (= ?w w2)))
                               (and (not (des ?w)) (des w2)))
                         (when (and (ind ?a ?w w3) (not (= ?w w3)))
                               (and (not (des ?w)) (des w3)))
                         (when (and (ind ?a ?w w4) (not (= ?w w4)))
                               (and (not (des ?w)) (des w4)))
                         (when (and (ind ?a ?w w5) (not (= ?w w5)))
                               (and (not (des ?w)) (des w5)))
                         (when (and (ind ?a ?w w6) (not (= ?w w6)))
                               (and (not (des ?w)) (des w6)))
                         (when (and (ind ?a ?w w7) (not (= ?w w7)))
                               (and (not (des ?w)) (des w7)))
                         (when (and (ind ?a ?w w8) (not (= ?w w8)))
                               (and (not (des ?w)) (des w8)))
                         (when (and (ind ?a ?w w9) (not (= ?w w9)))
                               (and (not (des ?w)) (des w9)))
                         (when (and (ind ?a ?w w10) (not (= ?w w10)))
                               (and (not (des ?w)) (des w10)))
                         (when (and (ind ?a ?w w11) (not (= ?w w11)))
                               (and (not (des ?w)) (des w11)))
                         (when (and (ind ?a ?w w12) (not (= ?w w12)))
                               (and (not (des ?w)) (des w12)))
                         (when (and (ind ?a ?w w13) (not (= ?w w13)))
                               (and (not (des ?w)) (des w13)))
                         (when (and (ind ?a ?w w14) (not (= ?w w14)))
                               (and (not (des ?w)) (des w14)))
                         (when (and (ind ?a ?w w15) (not (= ?w w15)))
                               (and (not (des ?w)) (des w15))))))
  (:action choose-announce ; UNFAIR ACTION!
     :parameters (?a - agt ?w - world ?p - pos)
     :precondition (and (des ?w) (next-choose)
                        (at ?a ?p) (goal ?w ?a ?p)
                        (not (stopped ?a)))
     :effect (and (next-annc ?a ?p) (not (next-choose))
                  (oneof 
                         (when (and (ind ?a ?w w0) (not (= ?w w0)))
                               (and (not (des ?w)) (des w0)))
                         (when (and (ind ?a ?w w1) (not (= ?w w1)))
                               (and (not (des ?w)) (des w1)))
                         (when (and (ind ?a ?w w2) (not (= ?w w2)))
                               (and (not (des ?w)) (des w2)))
                         (when (and (ind ?a ?w w3) (not (= ?w w3)))
                               (and (not (des ?w)) (des w3)))
                         (when (and (ind ?a ?w w4) (not (= ?w w4)))
                               (and (not (des ?w)) (des w4)))
                         (when (and (ind ?a ?w w5) (not (= ?w w5)))
                               (and (not (des ?w)) (des w5)))
                         (when (and (ind ?a ?w w6) (not (= ?w w6)))
                               (and (not (des ?w)) (des w6)))
                         (when (and (ind ?a ?w w7) (not (= ?w w7)))
                               (and (not (des ?w)) (des w7)))
                         (when (and (ind ?a ?w w8) (not (= ?w w8)))
                               (and (not (des ?w)) (des w8)))
                         (when (and (ind ?a ?w w9) (not (= ?w w9)))
                               (and (not (des ?w)) (des w9)))
                         (when (and (ind ?a ?w w10) (not (= ?w w10)))
                               (and (not (des ?w)) (des w10)))
                         (when (and (ind ?a ?w w11) (not (= ?w w11)))
                               (and (not (des ?w)) (des w11)))
                         (when (and (ind ?a ?w w12) (not (= ?w w12)))
                               (and (not (des ?w)) (des w12)))
                         (when (and (ind ?a ?w w13) (not (= ?w w13)))
                               (and (not (des ?w)) (des w13)))
                         (when (and (ind ?a ?w w14) (not (= ?w w14)))
                               (and (not (des ?w)) (des w14)))
                         (when (and (ind ?a ?w w15) (not (= ?w w15)))
                               (and (not (des ?w)) (des w15))))))
  (:action move
     :parameters (?a - agt ?w - world ?p1 ?p2 - pos)
     :precondition (and (des ?w) (next-move ?a ?p1 ?p2))
     :effect (and (not (at ?a ?p1)) (at ?a ?p2)
                  (not (next-move ?a ?p1 ?p2))
                  (next-choose)))
  (:action announce
     :parameters (?a - agt ?w - world ?p - pos)
     :precondition (and (des ?w) (next-annc ?a ?p)
                        (goal ?w ?a ?p))
     :effect (and (stopped ?a)
                  (not (next-annc ?a ?p)) (next-choose)
                  (when (not (goal w0 ?a ?p))
                        (and (not (ind a0 w0 w0)) (not (ind a0 w0 w0))
                             (not (ind a0 w0 w1)) (not (ind a0 w1 w0))
                             (not (ind a0 w0 w2)) (not (ind a0 w2 w0))
                             (not (ind a0 w0 w3)) (not (ind a0 w3 w0))
                             (not (ind a0 w0 w4)) (not (ind a0 w4 w0))
                             (not (ind a0 w0 w5)) (not (ind a0 w5 w0))
                             (not (ind a0 w0 w6)) (not (ind a0 w6 w0))
                             (not (ind a0 w0 w7)) (not (ind a0 w7 w0))
                             (not (ind a0 w0 w8)) (not (ind a0 w8 w0))
                             (not (ind a0 w0 w9)) (not (ind a0 w9 w0))
                             (not (ind a0 w0 w10)) (not (ind a0 w10 w0))
                             (not (ind a0 w0 w11)) (not (ind a0 w11 w0))
                             (not (ind a0 w0 w12)) (not (ind a0 w12 w0))
                             (not (ind a0 w0 w13)) (not (ind a0 w13 w0))
                             (not (ind a0 w0 w14)) (not (ind a0 w14 w0))
                             (not (ind a0 w0 w15)) (not (ind a0 w15 w0))
                             (not (ind a1 w0 w0)) (not (ind a1 w0 w0))
                             (not (ind a1 w0 w1)) (not (ind a1 w1 w0))
                             (not (ind a1 w0 w2)) (not (ind a1 w2 w0))
                             (not (ind a1 w0 w3)) (not (ind a1 w3 w0))
                             (not (ind a1 w0 w4)) (not (ind a1 w4 w0))
                             (not (ind a1 w0 w5)) (not (ind a1 w5 w0))
                             (not (ind a1 w0 w6)) (not (ind a1 w6 w0))
                             (not (ind a1 w0 w7)) (not (ind a1 w7 w0))
                             (not (ind a1 w0 w8)) (not (ind a1 w8 w0))
                             (not (ind a1 w0 w9)) (not (ind a1 w9 w0))
                             (not (ind a1 w0 w10)) (not (ind a1 w10 w0))
                             (not (ind a1 w0 w11)) (not (ind a1 w11 w0))
                             (not (ind a1 w0 w12)) (not (ind a1 w12 w0))
                             (not (ind a1 w0 w13)) (not (ind a1 w13 w0))
                             (not (ind a1 w0 w14)) (not (ind a1 w14 w0))
                             (not (ind a1 w0 w15)) (not (ind a1 w15 w0))
                             (not (ind a2 w0 w0)) (not (ind a2 w0 w0))
                             (not (ind a2 w0 w1)) (not (ind a2 w1 w0))
                             (not (ind a2 w0 w2)) (not (ind a2 w2 w0))
                             (not (ind a2 w0 w3)) (not (ind a2 w3 w0))
                             (not (ind a2 w0 w4)) (not (ind a2 w4 w0))
                             (not (ind a2 w0 w5)) (not (ind a2 w5 w0))
                             (not (ind a2 w0 w6)) (not (ind a2 w6 w0))
                             (not (ind a2 w0 w7)) (not (ind a2 w7 w0))
                             (not (ind a2 w0 w8)) (not (ind a2 w8 w0))
                             (not (ind a2 w0 w9)) (not (ind a2 w9 w0))
                             (not (ind a2 w0 w10)) (not (ind a2 w10 w0))
                             (not (ind a2 w0 w11)) (not (ind a2 w11 w0))
                             (not (ind a2 w0 w12)) (not (ind a2 w12 w0))
                             (not (ind a2 w0 w13)) (not (ind a2 w13 w0))
                             (not (ind a2 w0 w14)) (not (ind a2 w14 w0))
                             (not (ind a2 w0 w15)) (not (ind a2 w15 w0))
                             (not (ind a3 w0 w0)) (not (ind a3 w0 w0))
                             (not (ind a3 w0 w1)) (not (ind a3 w1 w0))
                             (not (ind a3 w0 w2)) (not (ind a3 w2 w0))
                             (not (ind a3 w0 w3)) (not (ind a3 w3 w0))
                             (not (ind a3 w0 w4)) (not (ind a3 w4 w0))
                             (not (ind a3 w0 w5)) (not (ind a3 w5 w0))
                             (not (ind a3 w0 w6)) (not (ind a3 w6 w0))
                             (not (ind a3 w0 w7)) (not (ind a3 w7 w0))
                             (not (ind a3 w0 w8)) (not (ind a3 w8 w0))
                             (not (ind a3 w0 w9)) (not (ind a3 w9 w0))
                             (not (ind a3 w0 w10)) (not (ind a3 w10 w0))
                             (not (ind a3 w0 w11)) (not (ind a3 w11 w0))
                             (not (ind a3 w0 w12)) (not (ind a3 w12 w0))
                             (not (ind a3 w0 w13)) (not (ind a3 w13 w0))
                             (not (ind a3 w0 w14)) (not (ind a3 w14 w0))
                             (not (ind a3 w0 w15)) (not (ind a3 w15 w0))))
                  (when (not (goal w1 ?a ?p))
                        (and (not (ind a0 w1 w0)) (not (ind a0 w0 w1))
                             (not (ind a0 w1 w1)) (not (ind a0 w1 w1))
                             (not (ind a0 w1 w2)) (not (ind a0 w2 w1))
                             (not (ind a0 w1 w3)) (not (ind a0 w3 w1))
                             (not (ind a0 w1 w4)) (not (ind a0 w4 w1))
                             (not (ind a0 w1 w5)) (not (ind a0 w5 w1))
                             (not (ind a0 w1 w6)) (not (ind a0 w6 w1))
                             (not (ind a0 w1 w7)) (not (ind a0 w7 w1))
                             (not (ind a0 w1 w8)) (not (ind a0 w8 w1))
                             (not (ind a0 w1 w9)) (not (ind a0 w9 w1))
                             (not (ind a0 w1 w10)) (not (ind a0 w10 w1))
                             (not (ind a0 w1 w11)) (not (ind a0 w11 w1))
                             (not (ind a0 w1 w12)) (not (ind a0 w12 w1))
                             (not (ind a0 w1 w13)) (not (ind a0 w13 w1))
                             (not (ind a0 w1 w14)) (not (ind a0 w14 w1))
                             (not (ind a0 w1 w15)) (not (ind a0 w15 w1))
                             (not (ind a1 w1 w0)) (not (ind a1 w0 w1))
                             (not (ind a1 w1 w1)) (not (ind a1 w1 w1))
                             (not (ind a1 w1 w2)) (not (ind a1 w2 w1))
                             (not (ind a1 w1 w3)) (not (ind a1 w3 w1))
                             (not (ind a1 w1 w4)) (not (ind a1 w4 w1))
                             (not (ind a1 w1 w5)) (not (ind a1 w5 w1))
                             (not (ind a1 w1 w6)) (not (ind a1 w6 w1))
                             (not (ind a1 w1 w7)) (not (ind a1 w7 w1))
                             (not (ind a1 w1 w8)) (not (ind a1 w8 w1))
                             (not (ind a1 w1 w9)) (not (ind a1 w9 w1))
                             (not (ind a1 w1 w10)) (not (ind a1 w10 w1))
                             (not (ind a1 w1 w11)) (not (ind a1 w11 w1))
                             (not (ind a1 w1 w12)) (not (ind a1 w12 w1))
                             (not (ind a1 w1 w13)) (not (ind a1 w13 w1))
                             (not (ind a1 w1 w14)) (not (ind a1 w14 w1))
                             (not (ind a1 w1 w15)) (not (ind a1 w15 w1))
                             (not (ind a2 w1 w0)) (not (ind a2 w0 w1))
                             (not (ind a2 w1 w1)) (not (ind a2 w1 w1))
                             (not (ind a2 w1 w2)) (not (ind a2 w2 w1))
                             (not (ind a2 w1 w3)) (not (ind a2 w3 w1))
                             (not (ind a2 w1 w4)) (not (ind a2 w4 w1))
                             (not (ind a2 w1 w5)) (not (ind a2 w5 w1))
                             (not (ind a2 w1 w6)) (not (ind a2 w6 w1))
                             (not (ind a2 w1 w7)) (not (ind a2 w7 w1))
                             (not (ind a2 w1 w8)) (not (ind a2 w8 w1))
                             (not (ind a2 w1 w9)) (not (ind a2 w9 w1))
                             (not (ind a2 w1 w10)) (not (ind a2 w10 w1))
                             (not (ind a2 w1 w11)) (not (ind a2 w11 w1))
                             (not (ind a2 w1 w12)) (not (ind a2 w12 w1))
                             (not (ind a2 w1 w13)) (not (ind a2 w13 w1))
                             (not (ind a2 w1 w14)) (not (ind a2 w14 w1))
                             (not (ind a2 w1 w15)) (not (ind a2 w15 w1))
                             (not (ind a3 w1 w0)) (not (ind a3 w0 w1))
                             (not (ind a3 w1 w1)) (not (ind a3 w1 w1))
                             (not (ind a3 w1 w2)) (not (ind a3 w2 w1))
                             (not (ind a3 w1 w3)) (not (ind a3 w3 w1))
                             (not (ind a3 w1 w4)) (not (ind a3 w4 w1))
                             (not (ind a3 w1 w5)) (not (ind a3 w5 w1))
                             (not (ind a3 w1 w6)) (not (ind a3 w6 w1))
                             (not (ind a3 w1 w7)) (not (ind a3 w7 w1))
                             (not (ind a3 w1 w8)) (not (ind a3 w8 w1))
                             (not (ind a3 w1 w9)) (not (ind a3 w9 w1))
                             (not (ind a3 w1 w10)) (not (ind a3 w10 w1))
                             (not (ind a3 w1 w11)) (not (ind a3 w11 w1))
                             (not (ind a3 w1 w12)) (not (ind a3 w12 w1))
                             (not (ind a3 w1 w13)) (not (ind a3 w13 w1))
                             (not (ind a3 w1 w14)) (not (ind a3 w14 w1))
                             (not (ind a3 w1 w15)) (not (ind a3 w15 w1))))
                  (when (not (goal w2 ?a ?p))
                        (and (not (ind a0 w2 w0)) (not (ind a0 w0 w2))
                             (not (ind a0 w2 w1)) (not (ind a0 w1 w2))
                             (not (ind a0 w2 w2)) (not (ind a0 w2 w2))
                             (not (ind a0 w2 w3)) (not (ind a0 w3 w2))
                             (not (ind a0 w2 w4)) (not (ind a0 w4 w2))
                             (not (ind a0 w2 w5)) (not (ind a0 w5 w2))
                             (not (ind a0 w2 w6)) (not (ind a0 w6 w2))
                             (not (ind a0 w2 w7)) (not (ind a0 w7 w2))
                             (not (ind a0 w2 w8)) (not (ind a0 w8 w2))
                             (not (ind a0 w2 w9)) (not (ind a0 w9 w2))
                             (not (ind a0 w2 w10)) (not (ind a0 w10 w2))
                             (not (ind a0 w2 w11)) (not (ind a0 w11 w2))
                             (not (ind a0 w2 w12)) (not (ind a0 w12 w2))
                             (not (ind a0 w2 w13)) (not (ind a0 w13 w2))
                             (not (ind a0 w2 w14)) (not (ind a0 w14 w2))
                             (not (ind a0 w2 w15)) (not (ind a0 w15 w2))
                             (not (ind a1 w2 w0)) (not (ind a1 w0 w2))
                             (not (ind a1 w2 w1)) (not (ind a1 w1 w2))
                             (not (ind a1 w2 w2)) (not (ind a1 w2 w2))
                             (not (ind a1 w2 w3)) (not (ind a1 w3 w2))
                             (not (ind a1 w2 w4)) (not (ind a1 w4 w2))
                             (not (ind a1 w2 w5)) (not (ind a1 w5 w2))
                             (not (ind a1 w2 w6)) (not (ind a1 w6 w2))
                             (not (ind a1 w2 w7)) (not (ind a1 w7 w2))
                             (not (ind a1 w2 w8)) (not (ind a1 w8 w2))
                             (not (ind a1 w2 w9)) (not (ind a1 w9 w2))
                             (not (ind a1 w2 w10)) (not (ind a1 w10 w2))
                             (not (ind a1 w2 w11)) (not (ind a1 w11 w2))
                             (not (ind a1 w2 w12)) (not (ind a1 w12 w2))
                             (not (ind a1 w2 w13)) (not (ind a1 w13 w2))
                             (not (ind a1 w2 w14)) (not (ind a1 w14 w2))
                             (not (ind a1 w2 w15)) (not (ind a1 w15 w2))
                             (not (ind a2 w2 w0)) (not (ind a2 w0 w2))
                             (not (ind a2 w2 w1)) (not (ind a2 w1 w2))
                             (not (ind a2 w2 w2)) (not (ind a2 w2 w2))
                             (not (ind a2 w2 w3)) (not (ind a2 w3 w2))
                             (not (ind a2 w2 w4)) (not (ind a2 w4 w2))
                             (not (ind a2 w2 w5)) (not (ind a2 w5 w2))
                             (not (ind a2 w2 w6)) (not (ind a2 w6 w2))
                             (not (ind a2 w2 w7)) (not (ind a2 w7 w2))
                             (not (ind a2 w2 w8)) (not (ind a2 w8 w2))
                             (not (ind a2 w2 w9)) (not (ind a2 w9 w2))
                             (not (ind a2 w2 w10)) (not (ind a2 w10 w2))
                             (not (ind a2 w2 w11)) (not (ind a2 w11 w2))
                             (not (ind a2 w2 w12)) (not (ind a2 w12 w2))
                             (not (ind a2 w2 w13)) (not (ind a2 w13 w2))
                             (not (ind a2 w2 w14)) (not (ind a2 w14 w2))
                             (not (ind a2 w2 w15)) (not (ind a2 w15 w2))
                             (not (ind a3 w2 w0)) (not (ind a3 w0 w2))
                             (not (ind a3 w2 w1)) (not (ind a3 w1 w2))
                             (not (ind a3 w2 w2)) (not (ind a3 w2 w2))
                             (not (ind a3 w2 w3)) (not (ind a3 w3 w2))
                             (not (ind a3 w2 w4)) (not (ind a3 w4 w2))
                             (not (ind a3 w2 w5)) (not (ind a3 w5 w2))
                             (not (ind a3 w2 w6)) (not (ind a3 w6 w2))
                             (not (ind a3 w2 w7)) (not (ind a3 w7 w2))
                             (not (ind a3 w2 w8)) (not (ind a3 w8 w2))
                             (not (ind a3 w2 w9)) (not (ind a3 w9 w2))
                             (not (ind a3 w2 w10)) (not (ind a3 w10 w2))
                             (not (ind a3 w2 w11)) (not (ind a3 w11 w2))
                             (not (ind a3 w2 w12)) (not (ind a3 w12 w2))
                             (not (ind a3 w2 w13)) (not (ind a3 w13 w2))
                             (not (ind a3 w2 w14)) (not (ind a3 w14 w2))
                             (not (ind a3 w2 w15)) (not (ind a3 w15 w2))))
                  (when (not (goal w3 ?a ?p))
                        (and (not (ind a0 w3 w0)) (not (ind a0 w0 w3))
                             (not (ind a0 w3 w1)) (not (ind a0 w1 w3))
                             (not (ind a0 w3 w2)) (not (ind a0 w2 w3))
                             (not (ind a0 w3 w3)) (not (ind a0 w3 w3))
                             (not (ind a0 w3 w4)) (not (ind a0 w4 w3))
                             (not (ind a0 w3 w5)) (not (ind a0 w5 w3))
                             (not (ind a0 w3 w6)) (not (ind a0 w6 w3))
                             (not (ind a0 w3 w7)) (not (ind a0 w7 w3))
                             (not (ind a0 w3 w8)) (not (ind a0 w8 w3))
                             (not (ind a0 w3 w9)) (not (ind a0 w9 w3))
                             (not (ind a0 w3 w10)) (not (ind a0 w10 w3))
                             (not (ind a0 w3 w11)) (not (ind a0 w11 w3))
                             (not (ind a0 w3 w12)) (not (ind a0 w12 w3))
                             (not (ind a0 w3 w13)) (not (ind a0 w13 w3))
                             (not (ind a0 w3 w14)) (not (ind a0 w14 w3))
                             (not (ind a0 w3 w15)) (not (ind a0 w15 w3))
                             (not (ind a1 w3 w0)) (not (ind a1 w0 w3))
                             (not (ind a1 w3 w1)) (not (ind a1 w1 w3))
                             (not (ind a1 w3 w2)) (not (ind a1 w2 w3))
                             (not (ind a1 w3 w3)) (not (ind a1 w3 w3))
                             (not (ind a1 w3 w4)) (not (ind a1 w4 w3))
                             (not (ind a1 w3 w5)) (not (ind a1 w5 w3))
                             (not (ind a1 w3 w6)) (not (ind a1 w6 w3))
                             (not (ind a1 w3 w7)) (not (ind a1 w7 w3))
                             (not (ind a1 w3 w8)) (not (ind a1 w8 w3))
                             (not (ind a1 w3 w9)) (not (ind a1 w9 w3))
                             (not (ind a1 w3 w10)) (not (ind a1 w10 w3))
                             (not (ind a1 w3 w11)) (not (ind a1 w11 w3))
                             (not (ind a1 w3 w12)) (not (ind a1 w12 w3))
                             (not (ind a1 w3 w13)) (not (ind a1 w13 w3))
                             (not (ind a1 w3 w14)) (not (ind a1 w14 w3))
                             (not (ind a1 w3 w15)) (not (ind a1 w15 w3))
                             (not (ind a2 w3 w0)) (not (ind a2 w0 w3))
                             (not (ind a2 w3 w1)) (not (ind a2 w1 w3))
                             (not (ind a2 w3 w2)) (not (ind a2 w2 w3))
                             (not (ind a2 w3 w3)) (not (ind a2 w3 w3))
                             (not (ind a2 w3 w4)) (not (ind a2 w4 w3))
                             (not (ind a2 w3 w5)) (not (ind a2 w5 w3))
                             (not (ind a2 w3 w6)) (not (ind a2 w6 w3))
                             (not (ind a2 w3 w7)) (not (ind a2 w7 w3))
                             (not (ind a2 w3 w8)) (not (ind a2 w8 w3))
                             (not (ind a2 w3 w9)) (not (ind a2 w9 w3))
                             (not (ind a2 w3 w10)) (not (ind a2 w10 w3))
                             (not (ind a2 w3 w11)) (not (ind a2 w11 w3))
                             (not (ind a2 w3 w12)) (not (ind a2 w12 w3))
                             (not (ind a2 w3 w13)) (not (ind a2 w13 w3))
                             (not (ind a2 w3 w14)) (not (ind a2 w14 w3))
                             (not (ind a2 w3 w15)) (not (ind a2 w15 w3))
                             (not (ind a3 w3 w0)) (not (ind a3 w0 w3))
                             (not (ind a3 w3 w1)) (not (ind a3 w1 w3))
                             (not (ind a3 w3 w2)) (not (ind a3 w2 w3))
                             (not (ind a3 w3 w3)) (not (ind a3 w3 w3))
                             (not (ind a3 w3 w4)) (not (ind a3 w4 w3))
                             (not (ind a3 w3 w5)) (not (ind a3 w5 w3))
                             (not (ind a3 w3 w6)) (not (ind a3 w6 w3))
                             (not (ind a3 w3 w7)) (not (ind a3 w7 w3))
                             (not (ind a3 w3 w8)) (not (ind a3 w8 w3))
                             (not (ind a3 w3 w9)) (not (ind a3 w9 w3))
                             (not (ind a3 w3 w10)) (not (ind a3 w10 w3))
                             (not (ind a3 w3 w11)) (not (ind a3 w11 w3))
                             (not (ind a3 w3 w12)) (not (ind a3 w12 w3))
                             (not (ind a3 w3 w13)) (not (ind a3 w13 w3))
                             (not (ind a3 w3 w14)) (not (ind a3 w14 w3))
                             (not (ind a3 w3 w15)) (not (ind a3 w15 w3))))
                  (when (not (goal w4 ?a ?p))
                        (and (not (ind a0 w4 w0)) (not (ind a0 w0 w4))
                             (not (ind a0 w4 w1)) (not (ind a0 w1 w4))
                             (not (ind a0 w4 w2)) (not (ind a0 w2 w4))
                             (not (ind a0 w4 w3)) (not (ind a0 w3 w4))
                             (not (ind a0 w4 w4)) (not (ind a0 w4 w4))
                             (not (ind a0 w4 w5)) (not (ind a0 w5 w4))
                             (not (ind a0 w4 w6)) (not (ind a0 w6 w4))
                             (not (ind a0 w4 w7)) (not (ind a0 w7 w4))
                             (not (ind a0 w4 w8)) (not (ind a0 w8 w4))
                             (not (ind a0 w4 w9)) (not (ind a0 w9 w4))
                             (not (ind a0 w4 w10)) (not (ind a0 w10 w4))
                             (not (ind a0 w4 w11)) (not (ind a0 w11 w4))
                             (not (ind a0 w4 w12)) (not (ind a0 w12 w4))
                             (not (ind a0 w4 w13)) (not (ind a0 w13 w4))
                             (not (ind a0 w4 w14)) (not (ind a0 w14 w4))
                             (not (ind a0 w4 w15)) (not (ind a0 w15 w4))
                             (not (ind a1 w4 w0)) (not (ind a1 w0 w4))
                             (not (ind a1 w4 w1)) (not (ind a1 w1 w4))
                             (not (ind a1 w4 w2)) (not (ind a1 w2 w4))
                             (not (ind a1 w4 w3)) (not (ind a1 w3 w4))
                             (not (ind a1 w4 w4)) (not (ind a1 w4 w4))
                             (not (ind a1 w4 w5)) (not (ind a1 w5 w4))
                             (not (ind a1 w4 w6)) (not (ind a1 w6 w4))
                             (not (ind a1 w4 w7)) (not (ind a1 w7 w4))
                             (not (ind a1 w4 w8)) (not (ind a1 w8 w4))
                             (not (ind a1 w4 w9)) (not (ind a1 w9 w4))
                             (not (ind a1 w4 w10)) (not (ind a1 w10 w4))
                             (not (ind a1 w4 w11)) (not (ind a1 w11 w4))
                             (not (ind a1 w4 w12)) (not (ind a1 w12 w4))
                             (not (ind a1 w4 w13)) (not (ind a1 w13 w4))
                             (not (ind a1 w4 w14)) (not (ind a1 w14 w4))
                             (not (ind a1 w4 w15)) (not (ind a1 w15 w4))
                             (not (ind a2 w4 w0)) (not (ind a2 w0 w4))
                             (not (ind a2 w4 w1)) (not (ind a2 w1 w4))
                             (not (ind a2 w4 w2)) (not (ind a2 w2 w4))
                             (not (ind a2 w4 w3)) (not (ind a2 w3 w4))
                             (not (ind a2 w4 w4)) (not (ind a2 w4 w4))
                             (not (ind a2 w4 w5)) (not (ind a2 w5 w4))
                             (not (ind a2 w4 w6)) (not (ind a2 w6 w4))
                             (not (ind a2 w4 w7)) (not (ind a2 w7 w4))
                             (not (ind a2 w4 w8)) (not (ind a2 w8 w4))
                             (not (ind a2 w4 w9)) (not (ind a2 w9 w4))
                             (not (ind a2 w4 w10)) (not (ind a2 w10 w4))
                             (not (ind a2 w4 w11)) (not (ind a2 w11 w4))
                             (not (ind a2 w4 w12)) (not (ind a2 w12 w4))
                             (not (ind a2 w4 w13)) (not (ind a2 w13 w4))
                             (not (ind a2 w4 w14)) (not (ind a2 w14 w4))
                             (not (ind a2 w4 w15)) (not (ind a2 w15 w4))
                             (not (ind a3 w4 w0)) (not (ind a3 w0 w4))
                             (not (ind a3 w4 w1)) (not (ind a3 w1 w4))
                             (not (ind a3 w4 w2)) (not (ind a3 w2 w4))
                             (not (ind a3 w4 w3)) (not (ind a3 w3 w4))
                             (not (ind a3 w4 w4)) (not (ind a3 w4 w4))
                             (not (ind a3 w4 w5)) (not (ind a3 w5 w4))
                             (not (ind a3 w4 w6)) (not (ind a3 w6 w4))
                             (not (ind a3 w4 w7)) (not (ind a3 w7 w4))
                             (not (ind a3 w4 w8)) (not (ind a3 w8 w4))
                             (not (ind a3 w4 w9)) (not (ind a3 w9 w4))
                             (not (ind a3 w4 w10)) (not (ind a3 w10 w4))
                             (not (ind a3 w4 w11)) (not (ind a3 w11 w4))
                             (not (ind a3 w4 w12)) (not (ind a3 w12 w4))
                             (not (ind a3 w4 w13)) (not (ind a3 w13 w4))
                             (not (ind a3 w4 w14)) (not (ind a3 w14 w4))
                             (not (ind a3 w4 w15)) (not (ind a3 w15 w4))))
                  (when (not (goal w5 ?a ?p))
                        (and (not (ind a0 w5 w0)) (not (ind a0 w0 w5))
                             (not (ind a0 w5 w1)) (not (ind a0 w1 w5))
                             (not (ind a0 w5 w2)) (not (ind a0 w2 w5))
                             (not (ind a0 w5 w3)) (not (ind a0 w3 w5))
                             (not (ind a0 w5 w4)) (not (ind a0 w4 w5))
                             (not (ind a0 w5 w5)) (not (ind a0 w5 w5))
                             (not (ind a0 w5 w6)) (not (ind a0 w6 w5))
                             (not (ind a0 w5 w7)) (not (ind a0 w7 w5))
                             (not (ind a0 w5 w8)) (not (ind a0 w8 w5))
                             (not (ind a0 w5 w9)) (not (ind a0 w9 w5))
                             (not (ind a0 w5 w10)) (not (ind a0 w10 w5))
                             (not (ind a0 w5 w11)) (not (ind a0 w11 w5))
                             (not (ind a0 w5 w12)) (not (ind a0 w12 w5))
                             (not (ind a0 w5 w13)) (not (ind a0 w13 w5))
                             (not (ind a0 w5 w14)) (not (ind a0 w14 w5))
                             (not (ind a0 w5 w15)) (not (ind a0 w15 w5))
                             (not (ind a1 w5 w0)) (not (ind a1 w0 w5))
                             (not (ind a1 w5 w1)) (not (ind a1 w1 w5))
                             (not (ind a1 w5 w2)) (not (ind a1 w2 w5))
                             (not (ind a1 w5 w3)) (not (ind a1 w3 w5))
                             (not (ind a1 w5 w4)) (not (ind a1 w4 w5))
                             (not (ind a1 w5 w5)) (not (ind a1 w5 w5))
                             (not (ind a1 w5 w6)) (not (ind a1 w6 w5))
                             (not (ind a1 w5 w7)) (not (ind a1 w7 w5))
                             (not (ind a1 w5 w8)) (not (ind a1 w8 w5))
                             (not (ind a1 w5 w9)) (not (ind a1 w9 w5))
                             (not (ind a1 w5 w10)) (not (ind a1 w10 w5))
                             (not (ind a1 w5 w11)) (not (ind a1 w11 w5))
                             (not (ind a1 w5 w12)) (not (ind a1 w12 w5))
                             (not (ind a1 w5 w13)) (not (ind a1 w13 w5))
                             (not (ind a1 w5 w14)) (not (ind a1 w14 w5))
                             (not (ind a1 w5 w15)) (not (ind a1 w15 w5))
                             (not (ind a2 w5 w0)) (not (ind a2 w0 w5))
                             (not (ind a2 w5 w1)) (not (ind a2 w1 w5))
                             (not (ind a2 w5 w2)) (not (ind a2 w2 w5))
                             (not (ind a2 w5 w3)) (not (ind a2 w3 w5))
                             (not (ind a2 w5 w4)) (not (ind a2 w4 w5))
                             (not (ind a2 w5 w5)) (not (ind a2 w5 w5))
                             (not (ind a2 w5 w6)) (not (ind a2 w6 w5))
                             (not (ind a2 w5 w7)) (not (ind a2 w7 w5))
                             (not (ind a2 w5 w8)) (not (ind a2 w8 w5))
                             (not (ind a2 w5 w9)) (not (ind a2 w9 w5))
                             (not (ind a2 w5 w10)) (not (ind a2 w10 w5))
                             (not (ind a2 w5 w11)) (not (ind a2 w11 w5))
                             (not (ind a2 w5 w12)) (not (ind a2 w12 w5))
                             (not (ind a2 w5 w13)) (not (ind a2 w13 w5))
                             (not (ind a2 w5 w14)) (not (ind a2 w14 w5))
                             (not (ind a2 w5 w15)) (not (ind a2 w15 w5))
                             (not (ind a3 w5 w0)) (not (ind a3 w0 w5))
                             (not (ind a3 w5 w1)) (not (ind a3 w1 w5))
                             (not (ind a3 w5 w2)) (not (ind a3 w2 w5))
                             (not (ind a3 w5 w3)) (not (ind a3 w3 w5))
                             (not (ind a3 w5 w4)) (not (ind a3 w4 w5))
                             (not (ind a3 w5 w5)) (not (ind a3 w5 w5))
                             (not (ind a3 w5 w6)) (not (ind a3 w6 w5))
                             (not (ind a3 w5 w7)) (not (ind a3 w7 w5))
                             (not (ind a3 w5 w8)) (not (ind a3 w8 w5))
                             (not (ind a3 w5 w9)) (not (ind a3 w9 w5))
                             (not (ind a3 w5 w10)) (not (ind a3 w10 w5))
                             (not (ind a3 w5 w11)) (not (ind a3 w11 w5))
                             (not (ind a3 w5 w12)) (not (ind a3 w12 w5))
                             (not (ind a3 w5 w13)) (not (ind a3 w13 w5))
                             (not (ind a3 w5 w14)) (not (ind a3 w14 w5))
                             (not (ind a3 w5 w15)) (not (ind a3 w15 w5))))
                  (when (not (goal w6 ?a ?p))
                        (and (not (ind a0 w6 w0)) (not (ind a0 w0 w6))
                             (not (ind a0 w6 w1)) (not (ind a0 w1 w6))
                             (not (ind a0 w6 w2)) (not (ind a0 w2 w6))
                             (not (ind a0 w6 w3)) (not (ind a0 w3 w6))
                             (not (ind a0 w6 w4)) (not (ind a0 w4 w6))
                             (not (ind a0 w6 w5)) (not (ind a0 w5 w6))
                             (not (ind a0 w6 w6)) (not (ind a0 w6 w6))
                             (not (ind a0 w6 w7)) (not (ind a0 w7 w6))
                             (not (ind a0 w6 w8)) (not (ind a0 w8 w6))
                             (not (ind a0 w6 w9)) (not (ind a0 w9 w6))
                             (not (ind a0 w6 w10)) (not (ind a0 w10 w6))
                             (not (ind a0 w6 w11)) (not (ind a0 w11 w6))
                             (not (ind a0 w6 w12)) (not (ind a0 w12 w6))
                             (not (ind a0 w6 w13)) (not (ind a0 w13 w6))
                             (not (ind a0 w6 w14)) (not (ind a0 w14 w6))
                             (not (ind a0 w6 w15)) (not (ind a0 w15 w6))
                             (not (ind a1 w6 w0)) (not (ind a1 w0 w6))
                             (not (ind a1 w6 w1)) (not (ind a1 w1 w6))
                             (not (ind a1 w6 w2)) (not (ind a1 w2 w6))
                             (not (ind a1 w6 w3)) (not (ind a1 w3 w6))
                             (not (ind a1 w6 w4)) (not (ind a1 w4 w6))
                             (not (ind a1 w6 w5)) (not (ind a1 w5 w6))
                             (not (ind a1 w6 w6)) (not (ind a1 w6 w6))
                             (not (ind a1 w6 w7)) (not (ind a1 w7 w6))
                             (not (ind a1 w6 w8)) (not (ind a1 w8 w6))
                             (not (ind a1 w6 w9)) (not (ind a1 w9 w6))
                             (not (ind a1 w6 w10)) (not (ind a1 w10 w6))
                             (not (ind a1 w6 w11)) (not (ind a1 w11 w6))
                             (not (ind a1 w6 w12)) (not (ind a1 w12 w6))
                             (not (ind a1 w6 w13)) (not (ind a1 w13 w6))
                             (not (ind a1 w6 w14)) (not (ind a1 w14 w6))
                             (not (ind a1 w6 w15)) (not (ind a1 w15 w6))
                             (not (ind a2 w6 w0)) (not (ind a2 w0 w6))
                             (not (ind a2 w6 w1)) (not (ind a2 w1 w6))
                             (not (ind a2 w6 w2)) (not (ind a2 w2 w6))
                             (not (ind a2 w6 w3)) (not (ind a2 w3 w6))
                             (not (ind a2 w6 w4)) (not (ind a2 w4 w6))
                             (not (ind a2 w6 w5)) (not (ind a2 w5 w6))
                             (not (ind a2 w6 w6)) (not (ind a2 w6 w6))
                             (not (ind a2 w6 w7)) (not (ind a2 w7 w6))
                             (not (ind a2 w6 w8)) (not (ind a2 w8 w6))
                             (not (ind a2 w6 w9)) (not (ind a2 w9 w6))
                             (not (ind a2 w6 w10)) (not (ind a2 w10 w6))
                             (not (ind a2 w6 w11)) (not (ind a2 w11 w6))
                             (not (ind a2 w6 w12)) (not (ind a2 w12 w6))
                             (not (ind a2 w6 w13)) (not (ind a2 w13 w6))
                             (not (ind a2 w6 w14)) (not (ind a2 w14 w6))
                             (not (ind a2 w6 w15)) (not (ind a2 w15 w6))
                             (not (ind a3 w6 w0)) (not (ind a3 w0 w6))
                             (not (ind a3 w6 w1)) (not (ind a3 w1 w6))
                             (not (ind a3 w6 w2)) (not (ind a3 w2 w6))
                             (not (ind a3 w6 w3)) (not (ind a3 w3 w6))
                             (not (ind a3 w6 w4)) (not (ind a3 w4 w6))
                             (not (ind a3 w6 w5)) (not (ind a3 w5 w6))
                             (not (ind a3 w6 w6)) (not (ind a3 w6 w6))
                             (not (ind a3 w6 w7)) (not (ind a3 w7 w6))
                             (not (ind a3 w6 w8)) (not (ind a3 w8 w6))
                             (not (ind a3 w6 w9)) (not (ind a3 w9 w6))
                             (not (ind a3 w6 w10)) (not (ind a3 w10 w6))
                             (not (ind a3 w6 w11)) (not (ind a3 w11 w6))
                             (not (ind a3 w6 w12)) (not (ind a3 w12 w6))
                             (not (ind a3 w6 w13)) (not (ind a3 w13 w6))
                             (not (ind a3 w6 w14)) (not (ind a3 w14 w6))
                             (not (ind a3 w6 w15)) (not (ind a3 w15 w6))))
                  (when (not (goal w7 ?a ?p))
                        (and (not (ind a0 w7 w0)) (not (ind a0 w0 w7))
                             (not (ind a0 w7 w1)) (not (ind a0 w1 w7))
                             (not (ind a0 w7 w2)) (not (ind a0 w2 w7))
                             (not (ind a0 w7 w3)) (not (ind a0 w3 w7))
                             (not (ind a0 w7 w4)) (not (ind a0 w4 w7))
                             (not (ind a0 w7 w5)) (not (ind a0 w5 w7))
                             (not (ind a0 w7 w6)) (not (ind a0 w6 w7))
                             (not (ind a0 w7 w7)) (not (ind a0 w7 w7))
                             (not (ind a0 w7 w8)) (not (ind a0 w8 w7))
                             (not (ind a0 w7 w9)) (not (ind a0 w9 w7))
                             (not (ind a0 w7 w10)) (not (ind a0 w10 w7))
                             (not (ind a0 w7 w11)) (not (ind a0 w11 w7))
                             (not (ind a0 w7 w12)) (not (ind a0 w12 w7))
                             (not (ind a0 w7 w13)) (not (ind a0 w13 w7))
                             (not (ind a0 w7 w14)) (not (ind a0 w14 w7))
                             (not (ind a0 w7 w15)) (not (ind a0 w15 w7))
                             (not (ind a1 w7 w0)) (not (ind a1 w0 w7))
                             (not (ind a1 w7 w1)) (not (ind a1 w1 w7))
                             (not (ind a1 w7 w2)) (not (ind a1 w2 w7))
                             (not (ind a1 w7 w3)) (not (ind a1 w3 w7))
                             (not (ind a1 w7 w4)) (not (ind a1 w4 w7))
                             (not (ind a1 w7 w5)) (not (ind a1 w5 w7))
                             (not (ind a1 w7 w6)) (not (ind a1 w6 w7))
                             (not (ind a1 w7 w7)) (not (ind a1 w7 w7))
                             (not (ind a1 w7 w8)) (not (ind a1 w8 w7))
                             (not (ind a1 w7 w9)) (not (ind a1 w9 w7))
                             (not (ind a1 w7 w10)) (not (ind a1 w10 w7))
                             (not (ind a1 w7 w11)) (not (ind a1 w11 w7))
                             (not (ind a1 w7 w12)) (not (ind a1 w12 w7))
                             (not (ind a1 w7 w13)) (not (ind a1 w13 w7))
                             (not (ind a1 w7 w14)) (not (ind a1 w14 w7))
                             (not (ind a1 w7 w15)) (not (ind a1 w15 w7))
                             (not (ind a2 w7 w0)) (not (ind a2 w0 w7))
                             (not (ind a2 w7 w1)) (not (ind a2 w1 w7))
                             (not (ind a2 w7 w2)) (not (ind a2 w2 w7))
                             (not (ind a2 w7 w3)) (not (ind a2 w3 w7))
                             (not (ind a2 w7 w4)) (not (ind a2 w4 w7))
                             (not (ind a2 w7 w5)) (not (ind a2 w5 w7))
                             (not (ind a2 w7 w6)) (not (ind a2 w6 w7))
                             (not (ind a2 w7 w7)) (not (ind a2 w7 w7))
                             (not (ind a2 w7 w8)) (not (ind a2 w8 w7))
                             (not (ind a2 w7 w9)) (not (ind a2 w9 w7))
                             (not (ind a2 w7 w10)) (not (ind a2 w10 w7))
                             (not (ind a2 w7 w11)) (not (ind a2 w11 w7))
                             (not (ind a2 w7 w12)) (not (ind a2 w12 w7))
                             (not (ind a2 w7 w13)) (not (ind a2 w13 w7))
                             (not (ind a2 w7 w14)) (not (ind a2 w14 w7))
                             (not (ind a2 w7 w15)) (not (ind a2 w15 w7))
                             (not (ind a3 w7 w0)) (not (ind a3 w0 w7))
                             (not (ind a3 w7 w1)) (not (ind a3 w1 w7))
                             (not (ind a3 w7 w2)) (not (ind a3 w2 w7))
                             (not (ind a3 w7 w3)) (not (ind a3 w3 w7))
                             (not (ind a3 w7 w4)) (not (ind a3 w4 w7))
                             (not (ind a3 w7 w5)) (not (ind a3 w5 w7))
                             (not (ind a3 w7 w6)) (not (ind a3 w6 w7))
                             (not (ind a3 w7 w7)) (not (ind a3 w7 w7))
                             (not (ind a3 w7 w8)) (not (ind a3 w8 w7))
                             (not (ind a3 w7 w9)) (not (ind a3 w9 w7))
                             (not (ind a3 w7 w10)) (not (ind a3 w10 w7))
                             (not (ind a3 w7 w11)) (not (ind a3 w11 w7))
                             (not (ind a3 w7 w12)) (not (ind a3 w12 w7))
                             (not (ind a3 w7 w13)) (not (ind a3 w13 w7))
                             (not (ind a3 w7 w14)) (not (ind a3 w14 w7))
                             (not (ind a3 w7 w15)) (not (ind a3 w15 w7))))
                  (when (not (goal w8 ?a ?p))
                        (and (not (ind a0 w8 w0)) (not (ind a0 w0 w8))
                             (not (ind a0 w8 w1)) (not (ind a0 w1 w8))
                             (not (ind a0 w8 w2)) (not (ind a0 w2 w8))
                             (not (ind a0 w8 w3)) (not (ind a0 w3 w8))
                             (not (ind a0 w8 w4)) (not (ind a0 w4 w8))
                             (not (ind a0 w8 w5)) (not (ind a0 w5 w8))
                             (not (ind a0 w8 w6)) (not (ind a0 w6 w8))
                             (not (ind a0 w8 w7)) (not (ind a0 w7 w8))
                             (not (ind a0 w8 w8)) (not (ind a0 w8 w8))
                             (not (ind a0 w8 w9)) (not (ind a0 w9 w8))
                             (not (ind a0 w8 w10)) (not (ind a0 w10 w8))
                             (not (ind a0 w8 w11)) (not (ind a0 w11 w8))
                             (not (ind a0 w8 w12)) (not (ind a0 w12 w8))
                             (not (ind a0 w8 w13)) (not (ind a0 w13 w8))
                             (not (ind a0 w8 w14)) (not (ind a0 w14 w8))
                             (not (ind a0 w8 w15)) (not (ind a0 w15 w8))
                             (not (ind a1 w8 w0)) (not (ind a1 w0 w8))
                             (not (ind a1 w8 w1)) (not (ind a1 w1 w8))
                             (not (ind a1 w8 w2)) (not (ind a1 w2 w8))
                             (not (ind a1 w8 w3)) (not (ind a1 w3 w8))
                             (not (ind a1 w8 w4)) (not (ind a1 w4 w8))
                             (not (ind a1 w8 w5)) (not (ind a1 w5 w8))
                             (not (ind a1 w8 w6)) (not (ind a1 w6 w8))
                             (not (ind a1 w8 w7)) (not (ind a1 w7 w8))
                             (not (ind a1 w8 w8)) (not (ind a1 w8 w8))
                             (not (ind a1 w8 w9)) (not (ind a1 w9 w8))
                             (not (ind a1 w8 w10)) (not (ind a1 w10 w8))
                             (not (ind a1 w8 w11)) (not (ind a1 w11 w8))
                             (not (ind a1 w8 w12)) (not (ind a1 w12 w8))
                             (not (ind a1 w8 w13)) (not (ind a1 w13 w8))
                             (not (ind a1 w8 w14)) (not (ind a1 w14 w8))
                             (not (ind a1 w8 w15)) (not (ind a1 w15 w8))
                             (not (ind a2 w8 w0)) (not (ind a2 w0 w8))
                             (not (ind a2 w8 w1)) (not (ind a2 w1 w8))
                             (not (ind a2 w8 w2)) (not (ind a2 w2 w8))
                             (not (ind a2 w8 w3)) (not (ind a2 w3 w8))
                             (not (ind a2 w8 w4)) (not (ind a2 w4 w8))
                             (not (ind a2 w8 w5)) (not (ind a2 w5 w8))
                             (not (ind a2 w8 w6)) (not (ind a2 w6 w8))
                             (not (ind a2 w8 w7)) (not (ind a2 w7 w8))
                             (not (ind a2 w8 w8)) (not (ind a2 w8 w8))
                             (not (ind a2 w8 w9)) (not (ind a2 w9 w8))
                             (not (ind a2 w8 w10)) (not (ind a2 w10 w8))
                             (not (ind a2 w8 w11)) (not (ind a2 w11 w8))
                             (not (ind a2 w8 w12)) (not (ind a2 w12 w8))
                             (not (ind a2 w8 w13)) (not (ind a2 w13 w8))
                             (not (ind a2 w8 w14)) (not (ind a2 w14 w8))
                             (not (ind a2 w8 w15)) (not (ind a2 w15 w8))
                             (not (ind a3 w8 w0)) (not (ind a3 w0 w8))
                             (not (ind a3 w8 w1)) (not (ind a3 w1 w8))
                             (not (ind a3 w8 w2)) (not (ind a3 w2 w8))
                             (not (ind a3 w8 w3)) (not (ind a3 w3 w8))
                             (not (ind a3 w8 w4)) (not (ind a3 w4 w8))
                             (not (ind a3 w8 w5)) (not (ind a3 w5 w8))
                             (not (ind a3 w8 w6)) (not (ind a3 w6 w8))
                             (not (ind a3 w8 w7)) (not (ind a3 w7 w8))
                             (not (ind a3 w8 w8)) (not (ind a3 w8 w8))
                             (not (ind a3 w8 w9)) (not (ind a3 w9 w8))
                             (not (ind a3 w8 w10)) (not (ind a3 w10 w8))
                             (not (ind a3 w8 w11)) (not (ind a3 w11 w8))
                             (not (ind a3 w8 w12)) (not (ind a3 w12 w8))
                             (not (ind a3 w8 w13)) (not (ind a3 w13 w8))
                             (not (ind a3 w8 w14)) (not (ind a3 w14 w8))
                             (not (ind a3 w8 w15)) (not (ind a3 w15 w8))))
                  (when (not (goal w9 ?a ?p))
                        (and (not (ind a0 w9 w0)) (not (ind a0 w0 w9))
                             (not (ind a0 w9 w1)) (not (ind a0 w1 w9))
                             (not (ind a0 w9 w2)) (not (ind a0 w2 w9))
                             (not (ind a0 w9 w3)) (not (ind a0 w3 w9))
                             (not (ind a0 w9 w4)) (not (ind a0 w4 w9))
                             (not (ind a0 w9 w5)) (not (ind a0 w5 w9))
                             (not (ind a0 w9 w6)) (not (ind a0 w6 w9))
                             (not (ind a0 w9 w7)) (not (ind a0 w7 w9))
                             (not (ind a0 w9 w8)) (not (ind a0 w8 w9))
                             (not (ind a0 w9 w9)) (not (ind a0 w9 w9))
                             (not (ind a0 w9 w10)) (not (ind a0 w10 w9))
                             (not (ind a0 w9 w11)) (not (ind a0 w11 w9))
                             (not (ind a0 w9 w12)) (not (ind a0 w12 w9))
                             (not (ind a0 w9 w13)) (not (ind a0 w13 w9))
                             (not (ind a0 w9 w14)) (not (ind a0 w14 w9))
                             (not (ind a0 w9 w15)) (not (ind a0 w15 w9))
                             (not (ind a1 w9 w0)) (not (ind a1 w0 w9))
                             (not (ind a1 w9 w1)) (not (ind a1 w1 w9))
                             (not (ind a1 w9 w2)) (not (ind a1 w2 w9))
                             (not (ind a1 w9 w3)) (not (ind a1 w3 w9))
                             (not (ind a1 w9 w4)) (not (ind a1 w4 w9))
                             (not (ind a1 w9 w5)) (not (ind a1 w5 w9))
                             (not (ind a1 w9 w6)) (not (ind a1 w6 w9))
                             (not (ind a1 w9 w7)) (not (ind a1 w7 w9))
                             (not (ind a1 w9 w8)) (not (ind a1 w8 w9))
                             (not (ind a1 w9 w9)) (not (ind a1 w9 w9))
                             (not (ind a1 w9 w10)) (not (ind a1 w10 w9))
                             (not (ind a1 w9 w11)) (not (ind a1 w11 w9))
                             (not (ind a1 w9 w12)) (not (ind a1 w12 w9))
                             (not (ind a1 w9 w13)) (not (ind a1 w13 w9))
                             (not (ind a1 w9 w14)) (not (ind a1 w14 w9))
                             (not (ind a1 w9 w15)) (not (ind a1 w15 w9))
                             (not (ind a2 w9 w0)) (not (ind a2 w0 w9))
                             (not (ind a2 w9 w1)) (not (ind a2 w1 w9))
                             (not (ind a2 w9 w2)) (not (ind a2 w2 w9))
                             (not (ind a2 w9 w3)) (not (ind a2 w3 w9))
                             (not (ind a2 w9 w4)) (not (ind a2 w4 w9))
                             (not (ind a2 w9 w5)) (not (ind a2 w5 w9))
                             (not (ind a2 w9 w6)) (not (ind a2 w6 w9))
                             (not (ind a2 w9 w7)) (not (ind a2 w7 w9))
                             (not (ind a2 w9 w8)) (not (ind a2 w8 w9))
                             (not (ind a2 w9 w9)) (not (ind a2 w9 w9))
                             (not (ind a2 w9 w10)) (not (ind a2 w10 w9))
                             (not (ind a2 w9 w11)) (not (ind a2 w11 w9))
                             (not (ind a2 w9 w12)) (not (ind a2 w12 w9))
                             (not (ind a2 w9 w13)) (not (ind a2 w13 w9))
                             (not (ind a2 w9 w14)) (not (ind a2 w14 w9))
                             (not (ind a2 w9 w15)) (not (ind a2 w15 w9))
                             (not (ind a3 w9 w0)) (not (ind a3 w0 w9))
                             (not (ind a3 w9 w1)) (not (ind a3 w1 w9))
                             (not (ind a3 w9 w2)) (not (ind a3 w2 w9))
                             (not (ind a3 w9 w3)) (not (ind a3 w3 w9))
                             (not (ind a3 w9 w4)) (not (ind a3 w4 w9))
                             (not (ind a3 w9 w5)) (not (ind a3 w5 w9))
                             (not (ind a3 w9 w6)) (not (ind a3 w6 w9))
                             (not (ind a3 w9 w7)) (not (ind a3 w7 w9))
                             (not (ind a3 w9 w8)) (not (ind a3 w8 w9))
                             (not (ind a3 w9 w9)) (not (ind a3 w9 w9))
                             (not (ind a3 w9 w10)) (not (ind a3 w10 w9))
                             (not (ind a3 w9 w11)) (not (ind a3 w11 w9))
                             (not (ind a3 w9 w12)) (not (ind a3 w12 w9))
                             (not (ind a3 w9 w13)) (not (ind a3 w13 w9))
                             (not (ind a3 w9 w14)) (not (ind a3 w14 w9))
                             (not (ind a3 w9 w15)) (not (ind a3 w15 w9))))
                  (when (not (goal w10 ?a ?p))
                        (and (not (ind a0 w10 w0)) (not (ind a0 w0 w10))
                             (not (ind a0 w10 w1)) (not (ind a0 w1 w10))
                             (not (ind a0 w10 w2)) (not (ind a0 w2 w10))
                             (not (ind a0 w10 w3)) (not (ind a0 w3 w10))
                             (not (ind a0 w10 w4)) (not (ind a0 w4 w10))
                             (not (ind a0 w10 w5)) (not (ind a0 w5 w10))
                             (not (ind a0 w10 w6)) (not (ind a0 w6 w10))
                             (not (ind a0 w10 w7)) (not (ind a0 w7 w10))
                             (not (ind a0 w10 w8)) (not (ind a0 w8 w10))
                             (not (ind a0 w10 w9)) (not (ind a0 w9 w10))
                             (not (ind a0 w10 w10)) (not (ind a0 w10 w10))
                             (not (ind a0 w10 w11)) (not (ind a0 w11 w10))
                             (not (ind a0 w10 w12)) (not (ind a0 w12 w10))
                             (not (ind a0 w10 w13)) (not (ind a0 w13 w10))
                             (not (ind a0 w10 w14)) (not (ind a0 w14 w10))
                             (not (ind a0 w10 w15)) (not (ind a0 w15 w10))
                             (not (ind a1 w10 w0)) (not (ind a1 w0 w10))
                             (not (ind a1 w10 w1)) (not (ind a1 w1 w10))
                             (not (ind a1 w10 w2)) (not (ind a1 w2 w10))
                             (not (ind a1 w10 w3)) (not (ind a1 w3 w10))
                             (not (ind a1 w10 w4)) (not (ind a1 w4 w10))
                             (not (ind a1 w10 w5)) (not (ind a1 w5 w10))
                             (not (ind a1 w10 w6)) (not (ind a1 w6 w10))
                             (not (ind a1 w10 w7)) (not (ind a1 w7 w10))
                             (not (ind a1 w10 w8)) (not (ind a1 w8 w10))
                             (not (ind a1 w10 w9)) (not (ind a1 w9 w10))
                             (not (ind a1 w10 w10)) (not (ind a1 w10 w10))
                             (not (ind a1 w10 w11)) (not (ind a1 w11 w10))
                             (not (ind a1 w10 w12)) (not (ind a1 w12 w10))
                             (not (ind a1 w10 w13)) (not (ind a1 w13 w10))
                             (not (ind a1 w10 w14)) (not (ind a1 w14 w10))
                             (not (ind a1 w10 w15)) (not (ind a1 w15 w10))
                             (not (ind a2 w10 w0)) (not (ind a2 w0 w10))
                             (not (ind a2 w10 w1)) (not (ind a2 w1 w10))
                             (not (ind a2 w10 w2)) (not (ind a2 w2 w10))
                             (not (ind a2 w10 w3)) (not (ind a2 w3 w10))
                             (not (ind a2 w10 w4)) (not (ind a2 w4 w10))
                             (not (ind a2 w10 w5)) (not (ind a2 w5 w10))
                             (not (ind a2 w10 w6)) (not (ind a2 w6 w10))
                             (not (ind a2 w10 w7)) (not (ind a2 w7 w10))
                             (not (ind a2 w10 w8)) (not (ind a2 w8 w10))
                             (not (ind a2 w10 w9)) (not (ind a2 w9 w10))
                             (not (ind a2 w10 w10)) (not (ind a2 w10 w10))
                             (not (ind a2 w10 w11)) (not (ind a2 w11 w10))
                             (not (ind a2 w10 w12)) (not (ind a2 w12 w10))
                             (not (ind a2 w10 w13)) (not (ind a2 w13 w10))
                             (not (ind a2 w10 w14)) (not (ind a2 w14 w10))
                             (not (ind a2 w10 w15)) (not (ind a2 w15 w10))
                             (not (ind a3 w10 w0)) (not (ind a3 w0 w10))
                             (not (ind a3 w10 w1)) (not (ind a3 w1 w10))
                             (not (ind a3 w10 w2)) (not (ind a3 w2 w10))
                             (not (ind a3 w10 w3)) (not (ind a3 w3 w10))
                             (not (ind a3 w10 w4)) (not (ind a3 w4 w10))
                             (not (ind a3 w10 w5)) (not (ind a3 w5 w10))
                             (not (ind a3 w10 w6)) (not (ind a3 w6 w10))
                             (not (ind a3 w10 w7)) (not (ind a3 w7 w10))
                             (not (ind a3 w10 w8)) (not (ind a3 w8 w10))
                             (not (ind a3 w10 w9)) (not (ind a3 w9 w10))
                             (not (ind a3 w10 w10)) (not (ind a3 w10 w10))
                             (not (ind a3 w10 w11)) (not (ind a3 w11 w10))
                             (not (ind a3 w10 w12)) (not (ind a3 w12 w10))
                             (not (ind a3 w10 w13)) (not (ind a3 w13 w10))
                             (not (ind a3 w10 w14)) (not (ind a3 w14 w10))
                             (not (ind a3 w10 w15)) (not (ind a3 w15 w10))))
                  (when (not (goal w11 ?a ?p))
                        (and (not (ind a0 w11 w0)) (not (ind a0 w0 w11))
                             (not (ind a0 w11 w1)) (not (ind a0 w1 w11))
                             (not (ind a0 w11 w2)) (not (ind a0 w2 w11))
                             (not (ind a0 w11 w3)) (not (ind a0 w3 w11))
                             (not (ind a0 w11 w4)) (not (ind a0 w4 w11))
                             (not (ind a0 w11 w5)) (not (ind a0 w5 w11))
                             (not (ind a0 w11 w6)) (not (ind a0 w6 w11))
                             (not (ind a0 w11 w7)) (not (ind a0 w7 w11))
                             (not (ind a0 w11 w8)) (not (ind a0 w8 w11))
                             (not (ind a0 w11 w9)) (not (ind a0 w9 w11))
                             (not (ind a0 w11 w10)) (not (ind a0 w10 w11))
                             (not (ind a0 w11 w11)) (not (ind a0 w11 w11))
                             (not (ind a0 w11 w12)) (not (ind a0 w12 w11))
                             (not (ind a0 w11 w13)) (not (ind a0 w13 w11))
                             (not (ind a0 w11 w14)) (not (ind a0 w14 w11))
                             (not (ind a0 w11 w15)) (not (ind a0 w15 w11))
                             (not (ind a1 w11 w0)) (not (ind a1 w0 w11))
                             (not (ind a1 w11 w1)) (not (ind a1 w1 w11))
                             (not (ind a1 w11 w2)) (not (ind a1 w2 w11))
                             (not (ind a1 w11 w3)) (not (ind a1 w3 w11))
                             (not (ind a1 w11 w4)) (not (ind a1 w4 w11))
                             (not (ind a1 w11 w5)) (not (ind a1 w5 w11))
                             (not (ind a1 w11 w6)) (not (ind a1 w6 w11))
                             (not (ind a1 w11 w7)) (not (ind a1 w7 w11))
                             (not (ind a1 w11 w8)) (not (ind a1 w8 w11))
                             (not (ind a1 w11 w9)) (not (ind a1 w9 w11))
                             (not (ind a1 w11 w10)) (not (ind a1 w10 w11))
                             (not (ind a1 w11 w11)) (not (ind a1 w11 w11))
                             (not (ind a1 w11 w12)) (not (ind a1 w12 w11))
                             (not (ind a1 w11 w13)) (not (ind a1 w13 w11))
                             (not (ind a1 w11 w14)) (not (ind a1 w14 w11))
                             (not (ind a1 w11 w15)) (not (ind a1 w15 w11))
                             (not (ind a2 w11 w0)) (not (ind a2 w0 w11))
                             (not (ind a2 w11 w1)) (not (ind a2 w1 w11))
                             (not (ind a2 w11 w2)) (not (ind a2 w2 w11))
                             (not (ind a2 w11 w3)) (not (ind a2 w3 w11))
                             (not (ind a2 w11 w4)) (not (ind a2 w4 w11))
                             (not (ind a2 w11 w5)) (not (ind a2 w5 w11))
                             (not (ind a2 w11 w6)) (not (ind a2 w6 w11))
                             (not (ind a2 w11 w7)) (not (ind a2 w7 w11))
                             (not (ind a2 w11 w8)) (not (ind a2 w8 w11))
                             (not (ind a2 w11 w9)) (not (ind a2 w9 w11))
                             (not (ind a2 w11 w10)) (not (ind a2 w10 w11))
                             (not (ind a2 w11 w11)) (not (ind a2 w11 w11))
                             (not (ind a2 w11 w12)) (not (ind a2 w12 w11))
                             (not (ind a2 w11 w13)) (not (ind a2 w13 w11))
                             (not (ind a2 w11 w14)) (not (ind a2 w14 w11))
                             (not (ind a2 w11 w15)) (not (ind a2 w15 w11))
                             (not (ind a3 w11 w0)) (not (ind a3 w0 w11))
                             (not (ind a3 w11 w1)) (not (ind a3 w1 w11))
                             (not (ind a3 w11 w2)) (not (ind a3 w2 w11))
                             (not (ind a3 w11 w3)) (not (ind a3 w3 w11))
                             (not (ind a3 w11 w4)) (not (ind a3 w4 w11))
                             (not (ind a3 w11 w5)) (not (ind a3 w5 w11))
                             (not (ind a3 w11 w6)) (not (ind a3 w6 w11))
                             (not (ind a3 w11 w7)) (not (ind a3 w7 w11))
                             (not (ind a3 w11 w8)) (not (ind a3 w8 w11))
                             (not (ind a3 w11 w9)) (not (ind a3 w9 w11))
                             (not (ind a3 w11 w10)) (not (ind a3 w10 w11))
                             (not (ind a3 w11 w11)) (not (ind a3 w11 w11))
                             (not (ind a3 w11 w12)) (not (ind a3 w12 w11))
                             (not (ind a3 w11 w13)) (not (ind a3 w13 w11))
                             (not (ind a3 w11 w14)) (not (ind a3 w14 w11))
                             (not (ind a3 w11 w15)) (not (ind a3 w15 w11))))
                  (when (not (goal w12 ?a ?p))
                        (and (not (ind a0 w12 w0)) (not (ind a0 w0 w12))
                             (not (ind a0 w12 w1)) (not (ind a0 w1 w12))
                             (not (ind a0 w12 w2)) (not (ind a0 w2 w12))
                             (not (ind a0 w12 w3)) (not (ind a0 w3 w12))
                             (not (ind a0 w12 w4)) (not (ind a0 w4 w12))
                             (not (ind a0 w12 w5)) (not (ind a0 w5 w12))
                             (not (ind a0 w12 w6)) (not (ind a0 w6 w12))
                             (not (ind a0 w12 w7)) (not (ind a0 w7 w12))
                             (not (ind a0 w12 w8)) (not (ind a0 w8 w12))
                             (not (ind a0 w12 w9)) (not (ind a0 w9 w12))
                             (not (ind a0 w12 w10)) (not (ind a0 w10 w12))
                             (not (ind a0 w12 w11)) (not (ind a0 w11 w12))
                             (not (ind a0 w12 w12)) (not (ind a0 w12 w12))
                             (not (ind a0 w12 w13)) (not (ind a0 w13 w12))
                             (not (ind a0 w12 w14)) (not (ind a0 w14 w12))
                             (not (ind a0 w12 w15)) (not (ind a0 w15 w12))
                             (not (ind a1 w12 w0)) (not (ind a1 w0 w12))
                             (not (ind a1 w12 w1)) (not (ind a1 w1 w12))
                             (not (ind a1 w12 w2)) (not (ind a1 w2 w12))
                             (not (ind a1 w12 w3)) (not (ind a1 w3 w12))
                             (not (ind a1 w12 w4)) (not (ind a1 w4 w12))
                             (not (ind a1 w12 w5)) (not (ind a1 w5 w12))
                             (not (ind a1 w12 w6)) (not (ind a1 w6 w12))
                             (not (ind a1 w12 w7)) (not (ind a1 w7 w12))
                             (not (ind a1 w12 w8)) (not (ind a1 w8 w12))
                             (not (ind a1 w12 w9)) (not (ind a1 w9 w12))
                             (not (ind a1 w12 w10)) (not (ind a1 w10 w12))
                             (not (ind a1 w12 w11)) (not (ind a1 w11 w12))
                             (not (ind a1 w12 w12)) (not (ind a1 w12 w12))
                             (not (ind a1 w12 w13)) (not (ind a1 w13 w12))
                             (not (ind a1 w12 w14)) (not (ind a1 w14 w12))
                             (not (ind a1 w12 w15)) (not (ind a1 w15 w12))
                             (not (ind a2 w12 w0)) (not (ind a2 w0 w12))
                             (not (ind a2 w12 w1)) (not (ind a2 w1 w12))
                             (not (ind a2 w12 w2)) (not (ind a2 w2 w12))
                             (not (ind a2 w12 w3)) (not (ind a2 w3 w12))
                             (not (ind a2 w12 w4)) (not (ind a2 w4 w12))
                             (not (ind a2 w12 w5)) (not (ind a2 w5 w12))
                             (not (ind a2 w12 w6)) (not (ind a2 w6 w12))
                             (not (ind a2 w12 w7)) (not (ind a2 w7 w12))
                             (not (ind a2 w12 w8)) (not (ind a2 w8 w12))
                             (not (ind a2 w12 w9)) (not (ind a2 w9 w12))
                             (not (ind a2 w12 w10)) (not (ind a2 w10 w12))
                             (not (ind a2 w12 w11)) (not (ind a2 w11 w12))
                             (not (ind a2 w12 w12)) (not (ind a2 w12 w12))
                             (not (ind a2 w12 w13)) (not (ind a2 w13 w12))
                             (not (ind a2 w12 w14)) (not (ind a2 w14 w12))
                             (not (ind a2 w12 w15)) (not (ind a2 w15 w12))
                             (not (ind a3 w12 w0)) (not (ind a3 w0 w12))
                             (not (ind a3 w12 w1)) (not (ind a3 w1 w12))
                             (not (ind a3 w12 w2)) (not (ind a3 w2 w12))
                             (not (ind a3 w12 w3)) (not (ind a3 w3 w12))
                             (not (ind a3 w12 w4)) (not (ind a3 w4 w12))
                             (not (ind a3 w12 w5)) (not (ind a3 w5 w12))
                             (not (ind a3 w12 w6)) (not (ind a3 w6 w12))
                             (not (ind a3 w12 w7)) (not (ind a3 w7 w12))
                             (not (ind a3 w12 w8)) (not (ind a3 w8 w12))
                             (not (ind a3 w12 w9)) (not (ind a3 w9 w12))
                             (not (ind a3 w12 w10)) (not (ind a3 w10 w12))
                             (not (ind a3 w12 w11)) (not (ind a3 w11 w12))
                             (not (ind a3 w12 w12)) (not (ind a3 w12 w12))
                             (not (ind a3 w12 w13)) (not (ind a3 w13 w12))
                             (not (ind a3 w12 w14)) (not (ind a3 w14 w12))
                             (not (ind a3 w12 w15)) (not (ind a3 w15 w12))))
                  (when (not (goal w13 ?a ?p))
                        (and (not (ind a0 w13 w0)) (not (ind a0 w0 w13))
                             (not (ind a0 w13 w1)) (not (ind a0 w1 w13))
                             (not (ind a0 w13 w2)) (not (ind a0 w2 w13))
                             (not (ind a0 w13 w3)) (not (ind a0 w3 w13))
                             (not (ind a0 w13 w4)) (not (ind a0 w4 w13))
                             (not (ind a0 w13 w5)) (not (ind a0 w5 w13))
                             (not (ind a0 w13 w6)) (not (ind a0 w6 w13))
                             (not (ind a0 w13 w7)) (not (ind a0 w7 w13))
                             (not (ind a0 w13 w8)) (not (ind a0 w8 w13))
                             (not (ind a0 w13 w9)) (not (ind a0 w9 w13))
                             (not (ind a0 w13 w10)) (not (ind a0 w10 w13))
                             (not (ind a0 w13 w11)) (not (ind a0 w11 w13))
                             (not (ind a0 w13 w12)) (not (ind a0 w12 w13))
                             (not (ind a0 w13 w13)) (not (ind a0 w13 w13))
                             (not (ind a0 w13 w14)) (not (ind a0 w14 w13))
                             (not (ind a0 w13 w15)) (not (ind a0 w15 w13))
                             (not (ind a1 w13 w0)) (not (ind a1 w0 w13))
                             (not (ind a1 w13 w1)) (not (ind a1 w1 w13))
                             (not (ind a1 w13 w2)) (not (ind a1 w2 w13))
                             (not (ind a1 w13 w3)) (not (ind a1 w3 w13))
                             (not (ind a1 w13 w4)) (not (ind a1 w4 w13))
                             (not (ind a1 w13 w5)) (not (ind a1 w5 w13))
                             (not (ind a1 w13 w6)) (not (ind a1 w6 w13))
                             (not (ind a1 w13 w7)) (not (ind a1 w7 w13))
                             (not (ind a1 w13 w8)) (not (ind a1 w8 w13))
                             (not (ind a1 w13 w9)) (not (ind a1 w9 w13))
                             (not (ind a1 w13 w10)) (not (ind a1 w10 w13))
                             (not (ind a1 w13 w11)) (not (ind a1 w11 w13))
                             (not (ind a1 w13 w12)) (not (ind a1 w12 w13))
                             (not (ind a1 w13 w13)) (not (ind a1 w13 w13))
                             (not (ind a1 w13 w14)) (not (ind a1 w14 w13))
                             (not (ind a1 w13 w15)) (not (ind a1 w15 w13))
                             (not (ind a2 w13 w0)) (not (ind a2 w0 w13))
                             (not (ind a2 w13 w1)) (not (ind a2 w1 w13))
                             (not (ind a2 w13 w2)) (not (ind a2 w2 w13))
                             (not (ind a2 w13 w3)) (not (ind a2 w3 w13))
                             (not (ind a2 w13 w4)) (not (ind a2 w4 w13))
                             (not (ind a2 w13 w5)) (not (ind a2 w5 w13))
                             (not (ind a2 w13 w6)) (not (ind a2 w6 w13))
                             (not (ind a2 w13 w7)) (not (ind a2 w7 w13))
                             (not (ind a2 w13 w8)) (not (ind a2 w8 w13))
                             (not (ind a2 w13 w9)) (not (ind a2 w9 w13))
                             (not (ind a2 w13 w10)) (not (ind a2 w10 w13))
                             (not (ind a2 w13 w11)) (not (ind a2 w11 w13))
                             (not (ind a2 w13 w12)) (not (ind a2 w12 w13))
                             (not (ind a2 w13 w13)) (not (ind a2 w13 w13))
                             (not (ind a2 w13 w14)) (not (ind a2 w14 w13))
                             (not (ind a2 w13 w15)) (not (ind a2 w15 w13))
                             (not (ind a3 w13 w0)) (not (ind a3 w0 w13))
                             (not (ind a3 w13 w1)) (not (ind a3 w1 w13))
                             (not (ind a3 w13 w2)) (not (ind a3 w2 w13))
                             (not (ind a3 w13 w3)) (not (ind a3 w3 w13))
                             (not (ind a3 w13 w4)) (not (ind a3 w4 w13))
                             (not (ind a3 w13 w5)) (not (ind a3 w5 w13))
                             (not (ind a3 w13 w6)) (not (ind a3 w6 w13))
                             (not (ind a3 w13 w7)) (not (ind a3 w7 w13))
                             (not (ind a3 w13 w8)) (not (ind a3 w8 w13))
                             (not (ind a3 w13 w9)) (not (ind a3 w9 w13))
                             (not (ind a3 w13 w10)) (not (ind a3 w10 w13))
                             (not (ind a3 w13 w11)) (not (ind a3 w11 w13))
                             (not (ind a3 w13 w12)) (not (ind a3 w12 w13))
                             (not (ind a3 w13 w13)) (not (ind a3 w13 w13))
                             (not (ind a3 w13 w14)) (not (ind a3 w14 w13))
                             (not (ind a3 w13 w15)) (not (ind a3 w15 w13))))
                  (when (not (goal w14 ?a ?p))
                        (and (not (ind a0 w14 w0)) (not (ind a0 w0 w14))
                             (not (ind a0 w14 w1)) (not (ind a0 w1 w14))
                             (not (ind a0 w14 w2)) (not (ind a0 w2 w14))
                             (not (ind a0 w14 w3)) (not (ind a0 w3 w14))
                             (not (ind a0 w14 w4)) (not (ind a0 w4 w14))
                             (not (ind a0 w14 w5)) (not (ind a0 w5 w14))
                             (not (ind a0 w14 w6)) (not (ind a0 w6 w14))
                             (not (ind a0 w14 w7)) (not (ind a0 w7 w14))
                             (not (ind a0 w14 w8)) (not (ind a0 w8 w14))
                             (not (ind a0 w14 w9)) (not (ind a0 w9 w14))
                             (not (ind a0 w14 w10)) (not (ind a0 w10 w14))
                             (not (ind a0 w14 w11)) (not (ind a0 w11 w14))
                             (not (ind a0 w14 w12)) (not (ind a0 w12 w14))
                             (not (ind a0 w14 w13)) (not (ind a0 w13 w14))
                             (not (ind a0 w14 w14)) (not (ind a0 w14 w14))
                             (not (ind a0 w14 w15)) (not (ind a0 w15 w14))
                             (not (ind a1 w14 w0)) (not (ind a1 w0 w14))
                             (not (ind a1 w14 w1)) (not (ind a1 w1 w14))
                             (not (ind a1 w14 w2)) (not (ind a1 w2 w14))
                             (not (ind a1 w14 w3)) (not (ind a1 w3 w14))
                             (not (ind a1 w14 w4)) (not (ind a1 w4 w14))
                             (not (ind a1 w14 w5)) (not (ind a1 w5 w14))
                             (not (ind a1 w14 w6)) (not (ind a1 w6 w14))
                             (not (ind a1 w14 w7)) (not (ind a1 w7 w14))
                             (not (ind a1 w14 w8)) (not (ind a1 w8 w14))
                             (not (ind a1 w14 w9)) (not (ind a1 w9 w14))
                             (not (ind a1 w14 w10)) (not (ind a1 w10 w14))
                             (not (ind a1 w14 w11)) (not (ind a1 w11 w14))
                             (not (ind a1 w14 w12)) (not (ind a1 w12 w14))
                             (not (ind a1 w14 w13)) (not (ind a1 w13 w14))
                             (not (ind a1 w14 w14)) (not (ind a1 w14 w14))
                             (not (ind a1 w14 w15)) (not (ind a1 w15 w14))
                             (not (ind a2 w14 w0)) (not (ind a2 w0 w14))
                             (not (ind a2 w14 w1)) (not (ind a2 w1 w14))
                             (not (ind a2 w14 w2)) (not (ind a2 w2 w14))
                             (not (ind a2 w14 w3)) (not (ind a2 w3 w14))
                             (not (ind a2 w14 w4)) (not (ind a2 w4 w14))
                             (not (ind a2 w14 w5)) (not (ind a2 w5 w14))
                             (not (ind a2 w14 w6)) (not (ind a2 w6 w14))
                             (not (ind a2 w14 w7)) (not (ind a2 w7 w14))
                             (not (ind a2 w14 w8)) (not (ind a2 w8 w14))
                             (not (ind a2 w14 w9)) (not (ind a2 w9 w14))
                             (not (ind a2 w14 w10)) (not (ind a2 w10 w14))
                             (not (ind a2 w14 w11)) (not (ind a2 w11 w14))
                             (not (ind a2 w14 w12)) (not (ind a2 w12 w14))
                             (not (ind a2 w14 w13)) (not (ind a2 w13 w14))
                             (not (ind a2 w14 w14)) (not (ind a2 w14 w14))
                             (not (ind a2 w14 w15)) (not (ind a2 w15 w14))
                             (not (ind a3 w14 w0)) (not (ind a3 w0 w14))
                             (not (ind a3 w14 w1)) (not (ind a3 w1 w14))
                             (not (ind a3 w14 w2)) (not (ind a3 w2 w14))
                             (not (ind a3 w14 w3)) (not (ind a3 w3 w14))
                             (not (ind a3 w14 w4)) (not (ind a3 w4 w14))
                             (not (ind a3 w14 w5)) (not (ind a3 w5 w14))
                             (not (ind a3 w14 w6)) (not (ind a3 w6 w14))
                             (not (ind a3 w14 w7)) (not (ind a3 w7 w14))
                             (not (ind a3 w14 w8)) (not (ind a3 w8 w14))
                             (not (ind a3 w14 w9)) (not (ind a3 w9 w14))
                             (not (ind a3 w14 w10)) (not (ind a3 w10 w14))
                             (not (ind a3 w14 w11)) (not (ind a3 w11 w14))
                             (not (ind a3 w14 w12)) (not (ind a3 w12 w14))
                             (not (ind a3 w14 w13)) (not (ind a3 w13 w14))
                             (not (ind a3 w14 w14)) (not (ind a3 w14 w14))
                             (not (ind a3 w14 w15)) (not (ind a3 w15 w14))))
                  (when (not (goal w15 ?a ?p))
                        (and (not (ind a0 w15 w0)) (not (ind a0 w0 w15))
                             (not (ind a0 w15 w1)) (not (ind a0 w1 w15))
                             (not (ind a0 w15 w2)) (not (ind a0 w2 w15))
                             (not (ind a0 w15 w3)) (not (ind a0 w3 w15))
                             (not (ind a0 w15 w4)) (not (ind a0 w4 w15))
                             (not (ind a0 w15 w5)) (not (ind a0 w5 w15))
                             (not (ind a0 w15 w6)) (not (ind a0 w6 w15))
                             (not (ind a0 w15 w7)) (not (ind a0 w7 w15))
                             (not (ind a0 w15 w8)) (not (ind a0 w8 w15))
                             (not (ind a0 w15 w9)) (not (ind a0 w9 w15))
                             (not (ind a0 w15 w10)) (not (ind a0 w10 w15))
                             (not (ind a0 w15 w11)) (not (ind a0 w11 w15))
                             (not (ind a0 w15 w12)) (not (ind a0 w12 w15))
                             (not (ind a0 w15 w13)) (not (ind a0 w13 w15))
                             (not (ind a0 w15 w14)) (not (ind a0 w14 w15))
                             (not (ind a0 w15 w15)) (not (ind a0 w15 w15))
                             (not (ind a1 w15 w0)) (not (ind a1 w0 w15))
                             (not (ind a1 w15 w1)) (not (ind a1 w1 w15))
                             (not (ind a1 w15 w2)) (not (ind a1 w2 w15))
                             (not (ind a1 w15 w3)) (not (ind a1 w3 w15))
                             (not (ind a1 w15 w4)) (not (ind a1 w4 w15))
                             (not (ind a1 w15 w5)) (not (ind a1 w5 w15))
                             (not (ind a1 w15 w6)) (not (ind a1 w6 w15))
                             (not (ind a1 w15 w7)) (not (ind a1 w7 w15))
                             (not (ind a1 w15 w8)) (not (ind a1 w8 w15))
                             (not (ind a1 w15 w9)) (not (ind a1 w9 w15))
                             (not (ind a1 w15 w10)) (not (ind a1 w10 w15))
                             (not (ind a1 w15 w11)) (not (ind a1 w11 w15))
                             (not (ind a1 w15 w12)) (not (ind a1 w12 w15))
                             (not (ind a1 w15 w13)) (not (ind a1 w13 w15))
                             (not (ind a1 w15 w14)) (not (ind a1 w14 w15))
                             (not (ind a1 w15 w15)) (not (ind a1 w15 w15))
                             (not (ind a2 w15 w0)) (not (ind a2 w0 w15))
                             (not (ind a2 w15 w1)) (not (ind a2 w1 w15))
                             (not (ind a2 w15 w2)) (not (ind a2 w2 w15))
                             (not (ind a2 w15 w3)) (not (ind a2 w3 w15))
                             (not (ind a2 w15 w4)) (not (ind a2 w4 w15))
                             (not (ind a2 w15 w5)) (not (ind a2 w5 w15))
                             (not (ind a2 w15 w6)) (not (ind a2 w6 w15))
                             (not (ind a2 w15 w7)) (not (ind a2 w7 w15))
                             (not (ind a2 w15 w8)) (not (ind a2 w8 w15))
                             (not (ind a2 w15 w9)) (not (ind a2 w9 w15))
                             (not (ind a2 w15 w10)) (not (ind a2 w10 w15))
                             (not (ind a2 w15 w11)) (not (ind a2 w11 w15))
                             (not (ind a2 w15 w12)) (not (ind a2 w12 w15))
                             (not (ind a2 w15 w13)) (not (ind a2 w13 w15))
                             (not (ind a2 w15 w14)) (not (ind a2 w14 w15))
                             (not (ind a2 w15 w15)) (not (ind a2 w15 w15))
                             (not (ind a3 w15 w0)) (not (ind a3 w0 w15))
                             (not (ind a3 w15 w1)) (not (ind a3 w1 w15))
                             (not (ind a3 w15 w2)) (not (ind a3 w2 w15))
                             (not (ind a3 w15 w3)) (not (ind a3 w3 w15))
                             (not (ind a3 w15 w4)) (not (ind a3 w4 w15))
                             (not (ind a3 w15 w5)) (not (ind a3 w5 w15))
                             (not (ind a3 w15 w6)) (not (ind a3 w6 w15))
                             (not (ind a3 w15 w7)) (not (ind a3 w7 w15))
                             (not (ind a3 w15 w8)) (not (ind a3 w8 w15))
                             (not (ind a3 w15 w9)) (not (ind a3 w9 w15))
                             (not (ind a3 w15 w10)) (not (ind a3 w10 w15))
                             (not (ind a3 w15 w11)) (not (ind a3 w11 w15))
                             (not (ind a3 w15 w12)) (not (ind a3 w12 w15))
                             (not (ind a3 w15 w13)) (not (ind a3 w13 w15))
                             (not (ind a3 w15 w14)) (not (ind a3 w14 w15))
                             (not (ind a3 w15 w15)) (not (ind a3 w15 w15)))))))
